package bingo.base;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextField;

import bingo.language.LanguageConstants;
import bingo.util.BINGODesktop;

/**
 *  Die Klasse bietet die Mglichkeit, in der Trainingsdatenbasis nach Begriffen
 *  (Texteingabe in Suchfenster) zu suchen. Tabellenzeilen, in denen der Begriff
 *  gefunden wird, werden hervorgehoben.
 *
 * @author     T.
 * @created    15. Juni 2001
 */
public class BaseSearchDialog extends JDialog implements ActionListener {

  private static LanguageConstants lc = LanguageConstants.getInstance();

  private JButton ok = new JButton( lc.get( "searchButton" ) );
  private JButton cancel = new JButton( lc.get( "cancel" ) );
  private JTextField text1 = new JTextField( 30 );
  private JPanel panel1 = new JPanel();
  private BaseSearchDialog dialog;

  private static String dialogTitle = lc.get( "search" );


  /**
   *  Konstruktor fr das SearchDialog Objekt
   *
   */
  public BaseSearchDialog() {
    super( BINGODesktop.getInstance(), dialogTitle, true );
    this.setSize( 200, 100 );

    Container content = this.getContentPane();

    content.setLayout( new BorderLayout() );

    dialog = this;

    KeyAdapter keyAdapter =
      new KeyAdapter() {
        public void keyPressed( KeyEvent e ) {
          if ( e.getKeyCode() == KeyEvent.VK_ENTER ) {
            BaseFrame bf = BaseFrame.getInstance();
            String s = text1.getText().toLowerCase();

            for ( int r = 0; r < bf.baseTable.getRowCount(); r++ ) {
              for ( int c = 0; c < bf.baseTable.getColumnCount(); c++ ) {
                if ( bf.baseTable.getValueAt( r, c ).toString().toLowerCase().indexOf( s ) >= 0 ) {
                  bf.addSelection( r );
                }
              }
            }
            dialog.dispose();
          } else if ( e.getKeyCode() == KeyEvent.VK_ESCAPE ) {
            dialog.dispose();
          }
        }
      };

    text1.addKeyListener( keyAdapter );

    panel1.setLayout( new FlowLayout() );
    panel1.add( ok );
    panel1.add( cancel );

    content.add( text1, BorderLayout.CENTER );
    content.add( panel1, BorderLayout.SOUTH );

    ok.addActionListener( this );
    cancel.addActionListener( this );

    setLocationRelativeTo( BINGODesktop.getInstance() );
  }


  /**
   *  berwacht die Buttons.
   *
   * @param  e  Das Event.
   */
  public void actionPerformed( ActionEvent e ) {
    String cmd = e.getActionCommand();

    if ( cmd == ( lc.get( "cancel" ) ) ) {
      BaseFrame bf = BaseFrame.getInstance();
      String s = text1.getText().toLowerCase();

      for ( int r = 0; r < bf.baseTable.getRowCount(); r++ ) {
        for ( int c = 0; c < bf.baseTable.getColumnCount(); c++ ) {
          if ( bf.baseTable.getValueAt( r, c ).toString().toLowerCase().indexOf( s ) >= 0 ) {
            bf.addSelection( r );
          }
        }
      }
      super.dispose();
    } else if ( cmd == ( lc.get( "searchButton" ) ) ) {
      super.dispose();
    }
  }
}

