package bingo.crawler;

import bingo.util.BingoDocument;

/**
 *  Klassifikator-Interface. Gemeinsame Schnittstelle fr unterschiedliche
 *  Klassifikator-Typen, die ein Objekt vom Typ Page bzw. BaseURL klassifizieren
 *  knnen.
 *
 * @author     T
 * @created    15. Juni 2001
 * @see        SVMTreeClassifier
 * @see        StandardClassifier
 */
public interface Classifier extends java.io.Serializable {

  /**
   *  Klassifiziert eine Page.
   *
   * @param  BingoDocument bd.
   */
  void classify( BingoDocument bd );

 /**
   *  Registriert einen Listener vom Typ SVMTreeListener zur Ausgabe von
   *  Klassifikationsereignissen.
   *
   * @param  l  Der Listener.
   */
  void registerListener( bingo.svmlight.SVMTreeListener l );

}

