package bingo.crawler;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;

import bingo.language.LanguageConstants;
import bingo.util.BINGODesktop;
import bingo.util.MimeType;
import bingo.util.SessionBuffer;
import bingo.util.TableSorter;
import bingo.util.URLClassTableModel;

/**
 *  Kontrolldialog fuer den Crawler.
 *
 * @author     T
 * @created    15. Juni 2001
 */
public class ControlDialog extends JDialog implements ActionListener, ItemListener
{
   
   SessionBuffer session = SessionBuffer.getInstance();
   
   private static LanguageConstants lc = LanguageConstants.getInstance();
   
   private Object[] domain_cb1 =
   {"Soft", "Hard"};
   private JComboBox cb1 = new JComboBox( domain_cb1 );
   private JCheckBox cb2 = new JCheckBox();
   
   private Object[] domain_cb3 =
   {"UNKNOWN", "SVM", "NONE"};
   private JComboBox cb3 = new JComboBox( domain_cb3 );
   private JTextField cb4 = new JTextField( 10 );
   private JTextField cb5 = new JTextField( 10 );
   private JCheckBox cb7 = new JCheckBox();
   private JTextField cb8 = new JTextField( 10 );
   private JTextField cb10 = new JTextField( 10 );
   private JCheckBox cb11 = new JCheckBox();
   private JTextField cb12 = new JTextField( 10 );
   
   private Object[] domain_cb13 =
   {"Classifier, Depth-First", "Classifier, Breadth-First", "Classifier", "Depth-First", "Breadth-First", "FIFO" };
   private JComboBox cb13 = new JComboBox( domain_cb13 );
   
   private JTextField cbr0 = new JTextField( 10 );
   private JTextField cbr1 = new JTextField( 10 );
   private JTextField cbr2 = new JTextField( 10 );
   private JTextField cbr5 = new JTextField( 10 );
   private JTextField cbr6 = new JTextField( 10 );
   private JCheckBox cbr7 = new JCheckBox();
   private JCheckBox cbr8 = new JCheckBox();
   private JTextField cbr9 = new JTextField( 10 );
   
   private JComboBox cbg1; // Men Sprache
   private JComboBox cbg2; // Stemmer Sprache
   private JTextField cbg3 = new JTextField(3); // LogLevel
   private JCheckBox cbg4 = new JCheckBox(); // ignoreNoSparse
   private JCheckBox cbg5 = new JCheckBox(); // useLinkTable
   private JTextField cbg6 = new JTextField(3);
   private JCheckBox cbg7 = new JCheckBox(); // enable StackTrace
   
   private String[] columnNames =
   {lc.get( "cDCol_1" ), lc.get( "cDCol_2" ),
    lc.get( "cDCol_3" ), lc.get( "cDCol_4" )};
    
    private TableSorter sorter;
    private final JTable table;
    private URLClassTableModel tableModel;
    
    private boolean dbConnect = true;
    
    JLabel l1 = new JLabel( lc.get( "cDFocus" ) );
    JLabel l2 = new JLabel( lc.get( "cDUploadStreams" ) );
    JLabel l3 = new JLabel( lc.get( "cDClassifier" ) );
    JLabel l4 = new JLabel( lc.get( "cDTunnel" ) );
    JLabel l5 = new JLabel( lc.get( "cDDepth" ) );
    JLabel l7 = new JLabel( lc.get( "cDGoogleQuery" ) );
    JLabel l8 = new JLabel( lc.get( "cDGoogleRelated" ) );
    JLabel l10 = new JLabel( lc.get( "cDGoogleLinks" ) );
    JLabel l11 = new JLabel( lc.get( "cDUseIndicators" ) );
    JLabel l12 = new JLabel( lc.get( "cDNumIndicators" ) );
    JLabel l13 = new JLabel( lc.get( "cDStrategy" ) );
    
    JLabel lr0 = new JLabel( lc.get( "cDTimeOut" ) );
    JLabel lr1 = new JLabel( lc.get( "cDThreads" ) );
    JLabel lr2 = new JLabel( lc.get( "cDBatch" ) );
    JLabel lr5 = new JLabel( lc.get( "cDChunk" ) );
    JLabel lr6 = new JLabel( lc.get( "cDQueue" ) );
    JLabel lr7 = new JLabel( lc.get( "cDOffline" ) );
    JLabel lr8 = new JLabel( lc.get( "cDHost" ) );
    JLabel lr9 = new JLabel( lc.get( "cDLinksPerDoc" ) );
    
    JLabel lg1 = new JLabel( lc.get( "cDLanguageLabel" ) );
    JLabel lg2 = new JLabel( lc.get( "cDstemmerLangLabel"));
    JLabel lg3 = new JLabel( lc.get( "cDLogLevel" ) );
    JLabel lg4 = new JLabel( lc.get( "cDignoreNoSparse" ) );
    JLabel lg5 = new JLabel( lc.get( "cDuseLinkTableLabel" ));
    JLabel lg6 = new JLabel( lc.get( "cDmaxVisiblePages" ));
    JLabel lg7 = new JLabel( lc.get( "cDshowStackTrace" ));
    
    public ControlDialog()
    {
       super( BINGODesktop.getInstance(), lc.get( "cDTitle" ), false );
       this.dbConnect = session.dbConnect;
       this.setSize( 400, 400 );
       
       // Sprachauswahlfeld initialisieren
       StringTokenizer tokDisplay = new StringTokenizer( lc.get( "cDLanguageSelect" ), ";" );
       StringTokenizer tokStemmer = new StringTokenizer( lc.get( "cDstemmerLangSelect" ), ";" );
       
       cbg1 = new JComboBox();
       cbg2 = new JComboBox();
       
       int i = -1;
       int j = -1;
       int indexDisplay = -1;
       int indexStemmer = -1;
       
       // Men Sprache
       while ( tokDisplay.hasMoreTokens() )
       {
          i++;
          
          String token = tokDisplay.nextToken().trim();
          
          cbg1.addItem( token );
          if ( token.equals( session.langFile ) )
          {
             indexDisplay = i;
          }
       }
       
       // Stemmer Sprache
       while ( tokStemmer.hasMoreTokens() )
       {
          j++;
          String sl = session.stemmerLanguage;
          
          //if (sl.equals("german")) 
             //sl = "deutsch";
          String token = tokStemmer.nextToken().trim();
          
          cbg2.addItem( token );
          if ( token.equals( sl ) )
          {
             indexStemmer = j;
          }
       }
       
       cbg1.setSelectedItem( cbg1.getItemAt( indexDisplay ) );
       cbg2.setSelectedItem(cbg2.getItemAt( indexStemmer ) );
       Container content = this.getContentPane();
       Container cont1 = new Container();
       Container cont2 = new Container();
       Container cont3 = new Container();
       Container cont4 = new Container();
       
       content.setLayout( new BorderLayout() );
       
       cont1.setLayout( new GridLayout( 10, 2, 14, 7 ) );
       cont2.setLayout( new GridLayout( 9, 2, 14, 7 ) );
       cont3.setLayout( new BorderLayout() );
       cont4.setLayout( new GridLayout( 7, 2, 14, 7 ) );
       
       JButton ok = new JButton( lc.get( "ok" ) );
       JButton cancel = new JButton( lc.get( "cancel" ) );
       JButton saveConfig = new JButton( lc.get( "cDSaveConfig" ) );
       JButton restoreDefault = new JButton( lc.get( "cDRestoreDefault" ) );
       JPanel buttonPanel = new JPanel();
       
       cb1.setBackground( Color.white );
       cb1.setForeground(Color.blue);
       
       cb3.setBackground( Color.white );
       cb5.setBackground( Color.white );
       cb8.setBackground( Color.white );
       
       cb13.setBackground( Color.white );
       cb13.setForeground( Color.blue );
       
       cont1.add( l3 );
       cont1.add( cb3 );
       
       cont1.add( l11 );    // Use Indicators
       cont1.add( cb11 );
       cont1.add( l12 );    // Num Indicators
       cont1.add( cb12 );
       
       cont1.add( l1 );
       cont1.add( cb1 );
       
       cont1.add( l13 );
       cont1.add( cb13 );
       
       cont1.add( l4 );
       cont1.add( cb4 );
       cont1.add( l7 );
       cont1.add( cb7 );
       cont1.add( l10 );
       cont1.add( cb10 );
       
       
       cont1.add( l8 );
       cont1.add( cb8 );
       cont1.add( l2 );
       cont1.add( cb2 );
       
       cbr0.setBackground( Color.white );
       cbr1.setBackground( Color.white );
       cbr9.setBackground( Color.white );
       
       cont2.add( l5 );
       cont2.add( cb5 );
       cont2.add( lr0 );
       cont2.add( cbr0 );
       cont2.add( lr1 );
       cont2.add( cbr1 );
       cont2.add( lr9 );
       cont2.add( cbr9 );
       cont2.add( lr7 );
       cont2.add( cbr7 );
       cont2.add( lr8 );
       cont2.add( cbr8 );
       cont2.add( lr2 );
       cont2.add( cbr2 );
       cont2.add( lr5 );
       cont2.add( cbr5 );
       cont2.add( lr6 );
       cont2.add( cbr6 );
       
       cont4.add( lg1 );
       cont4.add( cbg1 );
       cont4.add( lg2 );
       cont4.add( cbg2 );
       cont4.add( lg3 );
       cont4.add( cbg3 );
       cont4.add( lg4 );
       cont4.add( cbg4 );
       cont4.add( lg5 );
       cont4.add( cbg5 );
       cont4.add( lg6 );
       cont4.add( cbg6 );
       cont4.add( lg7 );
       cont4.add( cbg7);
       
       buttonPanel.add( ok );
       buttonPanel.add( cancel );
       buttonPanel.add( saveConfig );
       buttonPanel.add( restoreDefault );
       buttonPanel.setBackground( Color.gray );
       
       tableModel =
       new URLClassTableModel()
       {
          public boolean isCellEditable( int x, int y )
          {
             if ( y > 1 )
             {
                return true;
             } else
             {
                return false;
             }
          }
       };
       
       sorter = new TableSorter( tableModel );
       tableModel.setColumnNames( columnNames );
       table = new JTable( sorter );
       sorter.addMouseListenerToHeaderInTable( table );
       
       setMimeTypes();
       
       table.setBackground( Color.gray );
       table.setForeground( Color.white );
       
       cont3.add( new JScrollPane( table ), BorderLayout.CENTER );
       
       JTabbedPane tabbedPane = new JTabbedPane();
       
       tabbedPane.addTab( lc.get( "cDCrawler" ), cont1 );
       tabbedPane.addTab( lc.get( "cDDownload" ), cont2 );
       tabbedPane.addTab( lc.get( "cDMimeTypes" ), cont3 );
       tabbedPane.addTab( lc.get( "cDGeneral" ), cont4 );
       
       content.add( tabbedPane, BorderLayout.CENTER );
       content.add( buttonPanel, BorderLayout.SOUTH );
       
       ok.addActionListener( this );
       cancel.addActionListener( this );
       saveConfig.addActionListener( this );
       restoreDefault.addActionListener( this );
       
       initStandard();
       
       cbr7.addItemListener( this );
       //cb7.addItemListener( this );
       
       setLocationRelativeTo( BINGODesktop.getInstance() );
       
       controlDialog = this;
    }
    
    
    private void initStandard()
    {
       cb1.setSelectedIndex( session.softFocus ? 0 : 1 );
       cb2.setSelected( session.storeStreams );
       cb3.setSelectedIndex( session.useSVMClassifier );
       cb4.setText( String.valueOf( session.maxTunnelDistance ) );
       cb5.setText( String.valueOf( session.maxCrawlingDepth ) );
       cb7.setSelected( session.useGoogle );
       cb8.setText( String.valueOf( session.numGoogleRelated ) );
       cb10.setText( String.valueOf( session.numGoogleLink ) );
       cb13.setSelectedIndex(session.crawlStrategy);

       cb11.setSelected(session.useIndicators);                    // use Indicators
       cb12.setText(String.valueOf( session.numIndicators ));      // num Indicators
       
       cbr0.setText( String.valueOf( session.downloadTimeout ) );
       cbr1.setText( String.valueOf( session.maxCrawlerThreads ) );
       cbr2.setText( String.valueOf( session.batchSize ) );
       cbr5.setText( String.valueOf( session.chunkSize ) );
       cbr6.setText( String.valueOf( session.maxQueueSize ) );
       cbr7.setSelected( session.offlineCrawling );
       cbr8.setSelected( session.hostCrawling );
       cbr9.setText( String.valueOf( session.linksPerDoc ) );
       cbg4.setSelected( session.ignoreNoSparse );
       cbg5.setSelected(session.useLinkTable);
       cbg6.setText(String.valueOf(session.maxVisiblePages));
       cbg3.setText(String.valueOf( session.getLogLevel()) );
       cbg7.setSelected(session.getTraceFlag());
       
       if ( !dbConnect )
       {
          cb2.setEnabled( false );
          cbr2.setEnabled( false );
          cbr5.setEnabled( false );
          cbr7.setEnabled( false );
          
          cb11.setEnabled(false);
          cb12.setEnabled(false);
          
          session.offlineCrawling = false;
          l2.setEnabled( false );
          lr2.setEnabled( false );
          lr5.setEnabled( false );
          lr7.setEnabled( false );
       }
    }
    
    
    public void commitSettings()
    {
       session.softFocus = cb1.getSelectedIndex() == 0;
       session.hardFocus = cb1.getSelectedIndex() == 1;
       session.storeStreams = cb2.isSelected();
       session.useSVMClassifier = cb3.getSelectedIndex();
       session.useIndicators = cb11.isSelected();
       session.numIndicators = Integer.parseInt(cb12.getText());
       session.maxTunnelDistance = Integer.parseInt( cb4.getText() );
       session.maxCrawlingDepth = Integer.parseInt( cb5.getText() );
       session.useGoogle = cb7.isSelected();
       session.numGoogleLink = Integer.parseInt( cb10.getText() );
       session.numGoogleRelated = Integer.parseInt( cb8.getText() );
       session.downloadTimeout = Integer.parseInt( cbr0.getText() );
       session.linksPerDoc = Integer.parseInt( cbr9.getText() );
       session.maxCrawlerThreads = Integer.parseInt( cbr1.getText() );
       session.batchSize = Integer.parseInt( cbr2.getText() );
       session.chunkSize = Integer.parseInt( cbr5.getText() );
       session.maxQueueSize = Integer.parseInt( cbr6.getText() );
       session.offlineCrawling = cbr7.isSelected();
       session.hostCrawling = cbr8.isSelected();
       session.allowedMimes = getAllowedMimes();
       session.langFile = (String) cbg1.getSelectedItem();
       session.ignoreNoSparse = cbg4.isSelected();
       session.useLinkTable = cbg5.isSelected();
       session.maxVisiblePages = Integer.parseInt(cbg6.getText());
       session.setLogLevel( Integer.parseInt(cbg3.getText()));
       session.setTraceFlag( cbg7.isSelected() );
       
       session.crawlStrategy = cb1.getSelectedIndex();
       
       String stemmerLanguage = ((String) cbg2.getSelectedItem()).trim().toLowerCase();
       // if (stemmerLanguage.equals("deutsch")) stemmerLanguage = "german";
       session.setStemmerLanguage(stemmerLanguage);
       setMimeTypes();
       
       if (session.useIndicators)
       {
         session.loadIndicators();
       }   
    }
    
    
    /**
     *  berwacht die Mens.
     *
     * @param  e  Description of the Parameter
     */
    public void itemStateChanged( ItemEvent e )
    {
        /*if ( e.getSource() == cb7 ) {
            if ( !cb7.isSelected() ) {
                cb8.setText( "0" );
                cb10.setText( "0" );
            }
        }*/
    }
    
    
    /**
     *  berwacht die Buttons.
     *
     * @param  e  Das Event.
     */
    public void actionPerformed( ActionEvent e )
    {
       String cmd = e.getActionCommand();
       
       if ( cmd == ( lc.get( "cDSaveConfig" ) ) )
       {
          session.log( "selectedItem ==> " + cbg1.getSelectedItem(), 4 );
          if ( !session.langFile.equalsIgnoreCase( (String) cbg1.getSelectedItem() ) )
          {
             JOptionPane.showMessageDialog( this, lc.get( "cDRestartInfo" ), lc.get( "cDRestartTitle" ) + "!",
             JOptionPane.INFORMATION_MESSAGE );
          }
          commitSettings();
          session.saveConfig();
       } else if ( cmd == ( lc.get( "cDRestoreDefault" ) ) )
       {
          int resume = JOptionPane.showConfirmDialog( this,
          lc.get( "cDRestoreTitle" ), lc.get( "cDRestoreInfo" ) + "?", JOptionPane.YES_NO_OPTION,
          JOptionPane.WARNING_MESSAGE );
          
          if ( resume == JOptionPane.YES_OPTION )
          {
             session.restoreDefault();
             
             cb1.setSelectedIndex( session.softFocus ? 0 : 1 );
             cb2.setSelected( session.storeStreams );
             cb3.setSelectedIndex( session.useSVMClassifier );
             cb4.setText( String.valueOf( session.maxTunnelDistance ) );
             cb5.setText( String.valueOf( session.maxCrawlingDepth ) );
             cb7.setSelected( session.useGoogle );
             cb8.setText( String.valueOf( session.numGoogleRelated ) );
             cb10.setText( String.valueOf( session.numGoogleLink ) );
             
             cbr0.setText( String.valueOf( session.downloadTimeout ) );
             cbr1.setText( String.valueOf( session.maxCrawlerThreads ) );
             cbr2.setText( String.valueOf( session.batchSize ) );
             cbr5.setText( String.valueOf( session.chunkSize ) );
             cbr6.setText( String.valueOf( session.maxQueueSize ) );
             cbr7.setSelected( session.offlineCrawling );
             cbr8.setSelected( session.hostCrawling );
             
             cbg1.setSelectedItem( session.langFile );
             cbg2.setSelectedItem( session.stemmerLanguage );
             cbg4.setSelected( session.ignoreNoSparse );
             cbg6.setText(String.valueOf(session.maxVisiblePages));
             cbg3.setText( String.valueOf( session.getLogLevel()) );
             cbg7.setSelected( session.getTraceFlag() );
          }
       } else if ( cmd == ( lc.get( "ok" ) ) )
       {
          if ( !session.langFile.equalsIgnoreCase( (String) cbg1.getSelectedItem() ) )
          {
             JOptionPane.showMessageDialog( this, lc.get( "cDRestartInfo" ), lc.get( "cDRestartTitle" ) + "!",
             JOptionPane.INFORMATION_MESSAGE );
             commitSettings();
             session.saveConfig();
          } else
          {
             commitSettings();
          }
          setVisible( false );
       } else if ( cmd == ( lc.get( "cancel" ) ) )
       {
          setVisible( false );
       }
    }
    
    
    // Singleton
    private static ControlDialog controlDialog = null;
    
    
    /**
     *  Die Methode liefert die (einzige) Instanz der Klasse.
     *
     * @return    Die Instanz.
     */
    public static ControlDialog getInstance()
    {
       if ( controlDialog == null )
       {
          new ControlDialog();
       }
       return controlDialog;
    }
    
    
    private void setMimeTypes()
    {
       tableModel.setDataVector( new Vector() );
       
       Iterator it = session.allowedMimes.values().iterator();
       
       while ( it.hasNext() )
       {
          MimeType m = (MimeType) it.next();
          Object[] row =
          {
             m.getDescription(),
             m.getExtension(),
             new Integer( m.getMaxSize() ),
             Boolean.valueOf( m.isAllowed() )
          };
          
          tableModel.addRow( row );
       }
       it = session.allMimes.values().iterator();
       while ( it.hasNext() )
       {
          MimeType m = (MimeType) it.next();
          
          if ( session.allowedMimes.get( m.getDescription() ) == null )
          {
             Object[] row =
             {
                m.getDescription(),
                m.getExtension(),
                new Integer( m.getMaxSize() ),
                Boolean.valueOf( m.isAllowed() )
             };
             
             tableModel.addRow( row );
          }
       }
    }
    
    
    private HashMap getAllowedMimes()
    {
       HashMap result = new HashMap();
       
       try
       {
          for ( int i = 0; i < tableModel.getRowCount(); i++ )
          {
             boolean allowed;
             if ( ( allowed = ( (Boolean) tableModel.getValueAt( i, 3 ) ).booleanValue() ) )
             {
                int size = 0;
                
                try
                {
                   size = ( (Integer) tableModel.getValueAt( i, 2 ) ).intValue();
                }
                catch ( Exception e )
                {
                   session.log(e);
                }
                
                String description = (String) tableModel.getValueAt( i, 0 );
                String extension = (String) tableModel.getValueAt( i, 1 );
                
                result.put( description, new MimeType( extension, description, true, size ) );
             }
          }
       }
       catch ( Exception e )
       {
          session.log(e);
       }
       return result;
    }
    
    
    public String toString()
    {
       return lc.get( "cDToString" );
    }
    
    // zum Testen
    public static void main(String args[])
    {
       new ControlDialog().setVisible(true);
    }
    
}
