/*
 *  WebSPHINX web crawling toolkit
 *  Copyright (C) 1998,1999 Carnegie Mellon University
 *
 *  This library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation, version 2.
 *
 *  WebSPHINX homepage: http://www.cs.cmu.edu/~rcm/websphinx/
 */
package bingo.crawler;

/**
 *  Crawl event listener.
 *
 * @author     martin
 * @created    14. August 2002
 */
public interface CrawlListener {
  /**
   *  Notify that the crawler started.
   *
   * @param  event  Description of Parameter
   */
  void started( CrawlEvent event );


  /**
   *  Notify that the crawler ran out of links to crawl
   *
   * @param  event  Description of Parameter
   */
  void stopped( CrawlEvent event );


  /**
   *  Notify that the crawler's state was cleared.
   *
   * @param  event  Description of Parameter
   */
  void cleared( CrawlEvent event );


  /**
   *  Notify that the crawler timed out.
   *
   * @param  event  Description of Parameter
   */
  void timedOut( CrawlEvent event );


  /**
   *  Notify that the crawler was paused.
   *
   * @param  event  Description of Parameter
   */
  void paused( CrawlEvent event );

}
