package bingo.crawler;

import java.util.Vector;

/**
 *  Berechnet Prioritten fr Links die in der Crawler-Queue abgelegt werden.
 *
 * @author     T
 * @created    15. Juni 2001
 */
public class Priority {

  /**
   *  Liefert den Durchschnittswert einer Menge von Einzelprioritten oder 0
   *  falls die Menge leer ist.
   *
   * @param  singlePriorities  Die Einzelprioritten.
   * @return                   Der Durchschnittswert.
   */
  public static double getAverage( Vector singlePriorities ) {
    if ( singlePriorities.size() == 0 ) {
      return 0.0;
    }
    double d = 0.0;

    for ( int i = 0; i < singlePriorities.size(); i++ ) {
      d += ( (Double) singlePriorities.elementAt( i ) ).doubleValue();
    }
    d = d / singlePriorities.size();
    return d;
  }


  /**
   *  Liefert den letzten Wert einer Folge von Einzelprioritten oder 0 falls
   *  die Folge leer ist. Entspricht dem Abstand zur SVM-Hyperebene im letzten
   *  Klassifikationsschritt (fr Blattkategorie).
   *
   * @param  singlePriorities  Die Einzelprioritten.
   * @return                   Der letzte Wert.
   */
  public static double getLast( Vector singlePriorities ) {
    if ( singlePriorities.size() == 0 ) {
      return 0.0;
    }
    return ( (Double) singlePriorities.lastElement() ).doubleValue();
  }

}

