package bingo.crawler;

import bingo.crawler.frontier.url2resolve;
import bingo.db.DBInterface;
import bingo.util.BingoDocument;

public interface URL_Crawler {
	int maxHops = 5; // Anzahl redirects erlaubt

	void addLink(url2resolve u);

	DBInterface getDBInterface();

	void addLinkListener(LinkListener l);

	void removeLinkListener(LinkListener l);

	void addCrawlListener(CrawlListener c);

	void removeCrawlListener(CrawlListener c);

	void go();

	void stop();

	void reset();

	void putSuspended(url2resolve u);

	int countCrawled();

	int countSuspended();

	int countSlowHosts();

	int countActiveThreads();

	boolean isStopped();

	boolean isIdle();

	long getLifetime();

	void setLifetime(long t);

        boolean isAlreadyParsed(BingoDocument bd);
        
        public void resetLinkListeners();
        
        public void resetCrawlListeners();
}
