package bingo.crawler;

import java.net.HttpURLConnection;

import bingo.crawler.frontier.url2resolve;
import bingo.crawler.handler.CrawlHandler;
 
public class WormThread implements Runnable
{
    private BINGOCrawler parent;
    HttpURLConnection conn;
    private url2resolve u;
    boolean ready = false;
    CrawlHandler crawlHandler;
    
     
    public WormThread( BINGOCrawler c, url2resolve url2r, HttpURLConnection cn )
    {
        parent = c;
        u = url2r;
        conn = cn;
        ready = false;
    }
    
    
    public void run()
    {
        ready = false;
        
        crawlHandler = parent.handlerManager.getHandler( u, conn );
        
        crawlHandler.handle( parent, u, conn );
        ready = true;
        
        crawlHandler = null;
        
        synchronized ( parent )
        {
            parent.notifyAll();
        }
    }
    
    
    public boolean isReady()
    {
        return ready;
    }
    
    public void abortConnection()
    {
      try {crawlHandler.abortConnection();}
      catch(Exception e){}
      conn = null;
    }
    
}
