package bingo.crawler.frontier;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;

import bingo.util.MyInteger;
import bingo.util.SessionBuffer;

//=======================================================================================

public class OfflineClassQueue implements  Comparable
{
    static float loadFactor = (float)1.0;
    
    public ArrayList outgoing;
        
    public float access;
    static MyInteger counter;
    public int id;
    
    public HashSet visited;
    public HashSet inserted;
    
    private OfflineQueue parent;
    
    public int overflow = 0;
        
    public static int outMax = 200;
    // Max URLs in out-queue
    
    public String ontoClass;
    
    private SessionBuffer session = SessionBuffer.getInstance();
    
    public OfflineClassQueue(String myclass, OfflineQueue p)
    {    
        outgoing = new ArrayList((int)(1.5*outMax));
        
        parent = p;
        
        synchronized ( this.getClass() ) {
            if ( counter == null )
                counter = new MyInteger( 1 );
        }
        
        synchronized ( counter ) {
            counter.increase();
            this.id = counter.intValue();
        }
        
        ontoClass = myclass;
        overflow = 0;
        access = 0;
        
    }
    
    
    //=============  Methods for suspended Links ===========================
        
    public void destroy( url2resolve ziel ) {
        if ( ziel != null ) {
            ziel.parentDoc = null;
            ziel.url = null;
            ziel.IP = null;
        }
    }
    
    
    //========================================================
    
    public void addLink( url2resolve link )
    {
        url2resolve toForget=null;
        synchronized ( outgoing ) {
            int insertPosition = Collections.binarySearch(outgoing, link);
            if (insertPosition < 0)  // laut spezifikation
                insertPosition = -insertPosition-1;
            
            int currentSize = outgoing.size();
            if (currentSize < outMax)
                outgoing.add(insertPosition, link);
            else 
            {
                if (insertPosition > 0) {
                    toForget = (url2resolve)outgoing.get(0);
                    outgoing.remove(0);
                    outgoing.add(insertPosition-1, link);
                }
                else {
                    toForget=link;
                }
            }
        }
        
        synchronized (this)
        {this.notifyAll();}
        
        if (toForget!=null)
            forget(toForget);
        toForget=null;
    }
    
    //======================================================
    
    public void forget( Object u ) {
        parent.forget( u );
    }
    
    
    //======================================================
    
    public url2resolve getBest() {
        url2resolve tmp = null;
        boolean found = false;
        
        synchronized ( outgoing ) {
            if (outgoing.size() <= 0)
                return null;
            
            found = false;
            int count = outgoing.size()-1;
            while (!found && count >= 0) {
                tmp = (url2resolve) outgoing.get(count);
                if ( !parent.isLocked( tmp ) ) {
                    access += 0.001;
                    outgoing.remove(count);
                    found = true;
                }
                else {
                    count--;
                    tmp = null;
                }
            }
        }
        
        if ( found )
            synchronized(this)
            {this.notifyAll();}
            
            return tmp;
    }
    
    //===== Comparable Interface ==================================
    
    public int compareTo( Object o ) {
        int result = 0;
        
        if ( o == null )
            result = +1;
        else if ( access > ( (OfflineClassQueue) o ).access )
            result = +1;
        else if ( access < ( (OfflineClassQueue) o ).access )
            result = -1;
        else if ( this.id < ( (OfflineClassQueue) o ).id )
            result = -1;
        else if ( this.id > ( (OfflineClassQueue) o ).id )
            result = +1;
        
        return result;
    }
    
    //===== Comparable Interface ==================================
    
}
