package bingo.crawler.frontier;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import bingo.util.ImagePanel;
public class QueueWatcher extends JDialog
implements
Runnable,
ActionListener,
ItemListener
{
   // Grafische Oberflche
   KeyAdapter keyAdapter = new KeyAdapter()
   {
      public void keyPressed(KeyEvent e)
      {
         if (e.getKeyCode() == KeyEvent.VK_ENTER)
         {
            showShort();
         } else if (e.getKeyCode() == KeyEvent.VK_ESCAPE)
         {
            showEnd();
         }
      }
   };
   private JButton shortShow;
   private JButton fullShow;
   private boolean showShort = false;
   private boolean showFull = false;
   private boolean showEnd = false;
   URL_Queue parent = null;
   private long timeout = 100;
   long starttime;
   public QueueWatcher(URL_Queue p)
   {
      // super( JOptionPane.getFrameForComponent( comp ), "Watcher", true );
      parent = p;
      starttime = new Date().getTime();
      // Grafische Oberflche
      setSize(50, 150);
      String logo = "bingo/crawler/frontier/lupe.jpg";
      Container cont = this.getContentPane();
      //cont.setLayout( new GridLayout(2,1,10,10));
      JPanel panel = new ImagePanel(this.getClass().getClassLoader()
      .getResource(logo), new Dimension(100, 80));
      cont.add(panel, BorderLayout.CENTER);
      Container cont1 = new Container();
      cont1.setLayout(new GridLayout(2, 1));
      shortShow = new JButton("Short");
      shortShow.addActionListener(this);
      shortShow.addKeyListener(keyAdapter);
      cont1.add(shortShow);
      fullShow = new JButton("Full");
      fullShow.addActionListener(this);
      fullShow.addKeyListener(keyAdapter);
      cont1.add(fullShow);
      cont.add(cont1, BorderLayout.SOUTH);
      // setLocationRelativeTo( comp );
      show();
   }
   //==============================================
   public void showShort()
   {
      showShort = true;
   }
   public void showFull()
   {
      showShort = true;
      showFull = true;
   }
   public void showEnd()
   {
      showEnd = true;
   }
   public void itemStateChanged(ItemEvent evt)
   {
   }
   public void actionPerformed(ActionEvent evt)
   {
      Object source = evt.getSource();
      if (source == shortShow)
      {
         showShort();
      } else if (source == fullShow)
      {
         showFull();
      }
   }
   //==============================================
   public void run()
   {
      while (true)
      {
         showShort = false;
         showFull = false;
         showEnd = false;
         try
         {
            Thread.sleep(timeout);
         } catch (Exception e)
         {
         }
         if (showEnd)
         {
            hide();
            return;
         }
         if (showShort)
         {
            long acttime = new Date().getTime() - starttime;
            System.out.println("Queue Watcher at: "
            + ((int) (acttime / 1000)));
            System.out.println("  Cached by Name: "
            + (parent.visitedPath ).size());
            System.out.println("  Slow hosts: "
            + (parent.slowHosts ).getSize());
            System.out.println("  Locks: " + (parent.locks ).size());
         }
         if (showFull)
         {
            for (int i=0; i<parent.queuesArray.length;i++)
            {
               Class_Queue cq = (Class_Queue)parent.queuesArray[i];
               String ontoClass = cq.ontoClass;
               System.out.println(" Queue-Summary: " + ontoClass);
               System.out.println(" Array size: " + cq.sortedQueue.length);
               System.out.println(" Add pointer: " + cq.sortedQueueCounter);
               System.out.println(" Start pointer: " + cq.whereStartSearch);
               System.out.println(" Batch size: " + cq.accessCountBatch);
               System.out.println(" Last Attempts: " + cq.accessCount);
               System.out.println(" Attempts Batch: " + cq.accessCountBatch);

               System.out.println();
               System.out.println("Top-5 Queue Positions:");
               for (int x=1; x<=5; x++)
               {
                 url2resolve tmp = (url2resolve)cq.sortedQueue[cq.sortedQueue.length-x];
                 System.out.println ("[" + tmp.getPrio() + "] " + tmp.getURL());
               }
               
               System.out.println();
               System.out.println("Get-Best lookup:");
               url2resolve tmp = cq.getBest();
               if (tmp==null)
                  System.out.println ("..null");
               else
                  System.out.println (tmp.getURL());
               tmp = null;
            }     
         }
         
         if (showFull)
         {
            long before = new Date().getTime();
            url2resolve ul = parent.getBest();
            if (ul == null)
            {
               System.out.println("Achtung: Queue gibt null zurueck!");
            } 
            else
            {
               parent.unsetLock(ul);
            }
            long after = new Date().getTime();
            long pause = after - before;
            System.out.println(" Abfrage-Check: " + pause);
         }
         showShort = false;
         showFull = false;
      }
   }
}
