package bingo.crawler.frontier;

import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;

//=======================================================================================

public class timedList implements Runnable {
  private Hashtable hashList;
  private Enumeration enum;
  private long timeout = 1000;
  private timedListCallback back;


  public timedList( long t, int length ) {
    back = null;
    timeout = t;
    hashList = new Hashtable( length );
    new Thread( this ).start();
  }


  public timedList( long t ) {
    back = null;
    timeout = t;
    hashList = new Hashtable();
    ( new Thread( this ) ).start();
  }


  public timedList( long t, int length, timedListCallback b ) {
    back = b;
    timeout = t;
    hashList = new Hashtable( length );
    new Thread( this ).start();
  }


//==================================================================

  public void run() {
    // Bereinigung des Datenbestandes: alte Eintrge entfernen

    while ( true ) {

      try {
        Thread.sleep( timeout );
      }
      catch ( InterruptedException e ) {}

      long deadline = ( new Date() ).getTime();

      synchronized ( hashList ) {
        enum = hashList.keys();
        while ( enum.hasMoreElements() ) {
          Object key = enum.nextElement();
          timedListElement value = (timedListElement) hashList.get( key );

          if ( deadline - value.getTTL() > value.getCreated() ) {
            if ( back != null ) {
              back.takeBack( value );
            }
            hashList.remove( key );
          }
        }
      }
      System.gc();
    }
  }


//==================================================================

  public void put( Object key, Object value ) {
    hashList.put( key, value );
  }


  public Object get( Object key ) {
    return hashList.get( key );
  }


  public int getSize() {
    return hashList.size();
  }

}
