package bingo.crawler.frontier;

import java.util.Date;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.TreeSet;

import bingo.util.SessionBuffer;

//=======================================================================================

public class timedListOrdered implements Runnable {
  public TreeSet treeSet;

  private long timeout = 10 * 1000;
  private int size = 5000;
  private timedListCallback back;


  public timedListOrdered( long t, int length ) {
    back = null;
    timeout = t;
    treeSet = new TreeSet();
    new Thread( this ).start();
  }


  public timedListOrdered( long t ) {
    back = null;
    timeout = t;
    treeSet = new TreeSet();
    ( new Thread( this ) ).start();
  }


  public timedListOrdered( long t, int s, timedListCallback b ) {
    back = b;
    timeout = t;
    size = s;
    treeSet = new TreeSet();
    new Thread( this ).start();
  }


//==================================================================

  public void run() {
    // Bereinigung des Datenbestandes: alte Eintrge entfernen
    while ( true ) {

      try {
        Thread.sleep( timeout );
      }
      catch ( InterruptedException e ) {}

      long deadline = ( new Date() ).getTime();

      synchronized ( treeSet ) {
        Iterator it = treeSet.iterator();

        while ( it.hasNext() ) {
          timedListElement value = (timedListElement) it.next();

          if ( deadline - value.getTTL() > value.getCreated() ) {
            it.remove();
            if ( back != null ) {
              back.takeBack( value );
            }
          }
        }
      }
      System.gc();
    }
  }


//==================================================================

  public synchronized void put( Comparable elem ) {
    synchronized ( treeSet ) {
      if ( treeSet.size() < size ) {
        treeSet.add( elem );
      } else {
        try {
          Comparable tmp = (Comparable) treeSet.last();

          if ( tmp.compareTo( elem ) > 0 ) {
            Iterator it = treeSet.iterator();

            while ( it.hasNext() ) {
              it.next();
            }
            it.remove();
            it = null;
            treeSet.add( elem );
          } else {
            back.forget( elem );
          }
        }
        catch ( NoSuchElementException e ) {
          SessionBuffer.log(e);
        }
      }
    }
  }

}
