package bingo.crawler.handler;

import java.net.HttpURLConnection;

import bingo.crawler.URL_Crawler;
import bingo.crawler.frontier.url2resolve;
import bingo.util.BingoTreeNode;

//=======================================================================================

public class ClassifierHandler extends CrawlHandler
{
  public BingoTreeNode rootNode;
  
  public void handle( URL_Crawler uc, url2resolve u, HttpURLConnection c )
  {
    super.handle(uc,u,c);
    
    if ( !init( uc, u, c ) )
    {
      destroy();
      return;
    }
    
    // Use SVM Classifier: 0 = Unknown, 1 = SVM, 2 = AUS
    
    if ( session.useSVMClassifier == 0 )
    {
      bingoDoc.setStatus( 'U' );
      /*bingoDoc.setClassifiedNode( rootNode );*/
      bingoDoc.setNode( rootNode );
      bingoDoc.setSvmRank(new Double(0.0));
    } 
    else if ( session.useSVMClassifier == 2 )
    {
      // do nothing, vom Vorgaenger beibehalten !!
      bingoDoc.setStatus( 'C' );
      //bingoDoc.setClassifiedNode (bingoDoc.getRootNode());
      bingoDoc.setSvmRank(bingoDoc.getSvmRank());
    } 
    else
    {
      rootNode.classify(bingoDoc);
      bingoDoc.setStatus( 'C' );
    }  
    
    destroy();
  }
  
  //===============================================
  
  public void destroy()
  {
    super.destroy();
    rootNode = null;
  }
  
  
  public boolean init( URL_Crawler uc, url2resolve u, HttpURLConnection c )
  {
    if (!super.init(uc,u,c))
      return false;

    rootNode = session.getRootNode();
    if (rootNode==null)
      return false;
    
    return true;
  }
}
