package bingo.crawler.handler;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.util.Vector;

import bingo.crawler.URL_Crawler;
import bingo.crawler.frontier.url2resolve;
import bingo.util.BingoDocument;
import bingo.util.BingoTreeNode;
import bingo.util.SessionBuffer;

//=======================================================================================

public class CrawlHandler
{
   public Vector myAssistants;
   public URL_Crawler crawler;
   
   public url2resolve url2r = null;
   public HttpURLConnection conn;
   
   public int maxsize = 1024 * 512;
   public byte[] byteArray = null;
   public int byteArraySize = 0;
   
   public BingoTreeNode rootNode;
   InputStream input;
   
   protected SessionBuffer session = SessionBuffer.getInstance();
   protected BingoDocument bingoDoc = null;
   
   public void handle( URL_Crawler uc, url2resolve u, HttpURLConnection c )
   {
   }
   
   public void abortConnection()
   {
      if (conn!= null)
      {
         try
         {conn.disconnect();}
         catch (Exception e)
         { }
      }
      conn=null;
      
      if (input!= null)
      {
         try
         {input.close();}
         catch (Exception e)
         { }
      }
      input=null;
   }
   
   public URL_Crawler getCrawler()
   {return crawler;}
   
   public Vector getAssistants()
   {return myAssistants;}
   
   public void readContent()
   {
      if (conn == null || bingoDoc == null)
         return;
      
      int pagesize = bingoDoc.getContentLength();
      if (pagesize > 0)   // sonst -1, steht fuer unknown.
         byteArray = new byte[pagesize];
      else
         byteArray = new byte[maxsize];
      
      input = null;
      byteArraySize = 0;
      try
      {
         input = conn.getInputStream();
         int k = 0;
         do
         {
            int free = byteArray.length - byteArraySize;
            k = input.read(byteArray, byteArraySize, free);
            if (k > 0)
               byteArraySize += k;
         }
         while (k >= 0);
      }
      catch (Exception e)
      {
         session.log(e);
      }
      finally    // Auch unvollstaendige downloads werden unterstuetzt !!!
      {
         try
         {
            if (input != null)
            {
               input.close();
            }
         }
         catch (Exception e)
         { }
         input = null;
         bingoDoc.setBulkSize(byteArraySize);
         //System.out.println("------------------------------------- bulksize " + byteArraySize);
      }
   }
   
   public InputStream getContentStream()
   {
      if (byteArray == null
      || byteArray.length <= 0
      || byteArray.length < byteArraySize
      || byteArraySize <= 0)
         return null;
      
      ByteArrayInputStream result = new ByteArrayInputStream(byteArray, 0, byteArraySize);
      return result;
   }
   
   public void destroy()
   {
      myAssistants = null;
      crawler = null;
      session = null;
      rootNode = null;
      
      bingoDoc = null;
      url2r = null;
      
      conn = null;
      input = null;
      byteArray = null;
      byteArraySize = -1;
   }
   
   public boolean init( URL_Crawler uc, url2resolve u, HttpURLConnection c )
   {
      if (uc == null || u==null || c==null)
         return false;
      
      crawler = uc;
      url2r = u;
      conn = c;
      
      bingoDoc = u.parentDoc;
      if ( bingoDoc == null )
         return false;
      
      
      
      rootNode = session.getRootNode();
      if (rootNode == null)
         return false;
      
      return true;
   }
   
   public boolean init(URL_Crawler uc, BingoDocument bd)
   {
      if (uc == null || bd == null)
         return false;
      
      crawler = uc;
      url2r = null;
      conn = null;
      bingoDoc = bd;
      
      rootNode = session.getRootNode();
      if (rootNode == null)
         return false;
      
      return true;
   }
   
   public void wait4assis()
   {
      if (myAssistants == null)
         return;
      
      while ( myAssistants.size() > 0 )
      {
         try
         {
            synchronized ( myAssistants )
            {
               if ( myAssistants.size() > 0 )
                  myAssistants.wait();
            }
         }
         catch ( Exception e )
         {
            session.log(e);
         }
      }
   }
   
}