package bingo.crawler.handler;

import java.io.File;
import java.net.HttpURLConnection;
import java.net.URL;

import bingo.util.BingoDocument;
import bingo.crawler.URL_Crawler;
import bingo.crawler.frontier.url2resolve;

//=======================================================================================

public class ParentDirectoryHandler extends CrawlHandler
{
    private URL url;
    private File file;
    private String parentDir;
    private UrlVerifier urlVerifier;
    
    public void handle( URL_Crawler uc, url2resolve u, HttpURLConnection c )
    {
        super.handle (uc,u,c);
        if ( !init( uc, u, c ) )
        {
            destroy();
            return;
        }
        
        if ( ( bingoDoc.getUrl() ).indexOf( "?" ) > 0 )
        {
            // eine Form mit Parametern
            
            destroy();
            return;
        }
        
        url = u.getURL();
        if ( url != null )
        {
            file = new File( url.getFile() );
            parentDir = file.getParent();
            
            if ( parentDir != null )
            {
                parentDir = parentDir.replace( '\\', '/' ) + "/";
                // Letzter Slash am Ende
                URL tempURL = urlVerifier.checkLink( parentDir );
                if ( tempURL != null )
                    bingoDoc.addLink( tempURL );
                tempURL=null; parentDir = null;
                //     SessionBuffer.log("Parent: " + query.url2r.getURL(), 5);
            }
        }
        destroy();
    }
    
    public void destroy()
    {
        super.destroy();
        file = null;
        url = null;
        parentDir = null;
        
        if ( urlVerifier != null )
            urlVerifier.destroy();
        urlVerifier = null;
    }
    
    
    public boolean init( URL_Crawler uc, url2resolve u, HttpURLConnection c )
    {
        if (!super.init(uc,u,c))
            return false;
        
        urlVerifier = new UrlVerifier( u );
        
        return true;
    }
    
}