package bingo.crawler.handler;

import java.net.HttpURLConnection;
import java.net.URL;

import bingo.util.BingoDocument;
import bingo.crawler.URL_Crawler;
import bingo.crawler.frontier.url2resolve;
import bingo.util.SessionBuffer;

//=======================================================================================

public class RedirectHandler extends CrawlHandler
{
   String redirect = null;
   BingoDocument newDoc;
   UrlVerifier urlVerifier;
   
   
  /*
   *  Handle eine Antwort mit redirect-code im response
   */
   public void handle( URL_Crawler uc, url2resolve u, HttpURLConnection c )
   {
      if ( !init( uc, u, c ) )
      {
         destroy();
         return;
      }
      
      SessionBuffer.log( "Response REDIRECT ", 3);
      process();
      destroy();
   }
   
   
  /*
   *  Allg. Bearbeitungsschritte einer Weiterleitung
   */
   public void process()
   {
      // Ziel als Link desselben Typs und der gleichen Tiefe behandeln
      bingoDoc.setRedirect(true);
      
      // bingoDoc.setNode( session.getRootNode() );
      if (bingoDoc.getHops() < crawler.maxHops)
      {
         String redirect = conn.getHeaderField( "Location" );  
         if (redirect != null)
         {   
           URL target = urlVerifier.checkLink(redirect);
           if (target != null)
              bingoDoc.addLink(target);
           target = null;
         } 
      }
      
      new LinkHandler().handle( crawler, url2r, conn );
      bingoDoc.setStatus ('R');
      new StoreHandler().handle( crawler, url2r, conn );
   }
   
   
   //========================================================
   
   public void destroy()
   {
      super.destroy();
      newDoc = null;
      if ( urlVerifier != null )
         urlVerifier.destroy();
      urlVerifier = null;
   }
   
   
   public boolean init( URL_Crawler uc, url2resolve u, HttpURLConnection c )
   {
      if (!super.init(uc,u,c))
         return false;
      
      urlVerifier = new UrlVerifier( u );
      
      return true;
   }
   
}
