package bingo.crawler.handler;
import java.net.HttpURLConnection;
import bingo.crawler.URL_Crawler;
import bingo.crawler.frontier.url2resolve;
import bingo.db.DBInterface;
//=======================================================================================
public class StoreHandler extends CrawlHandler
{
   DBInterface dbinterface = null;
   public void handle(URL_Crawler uc, url2resolve u, HttpURLConnection c)
   {
      if (!init(uc, u, c))
      {
         destroy();
         return;
      }
      
      if (bingoDoc.getStatus() == 'B' || bingoDoc.getStatus() == 'J')
      {
         // Bookmarks
         if (!bingoDoc.isBroken())
         {
            dbinterface.pushTrainingDocument(bingoDoc);
            dbinterface.pushNested(bingoDoc);
         }
      }
      else if (bingoDoc.getStatus() == 'D')     // Duplikat, erkannt aus Content-Signatur
      {
         if (!bingoDoc.isBroken())
         {
            dbinterface.pushDuplicate(bingoDoc);
         }
      } 
      else if (bingoDoc.getStatus() == 'C')
      {
         // Classified Documents
         if (bingoDoc.getNode() != rootNode)
         {
            // positiv klassifiziert
            if (!bingoDoc.isBroken())
            {
               dbinterface.pushLink(bingoDoc);
               dbinterface.pushNested(bingoDoc);
            }
         } else
         {
            // negativ klassifiziert
            if (!bingoDoc.isBroken())
            {
               dbinterface.pushLink(bingoDoc);
               dbinterface
               .pushLinks(bingoDoc.getId(), bingoDoc.getLinks());
            }
            //if (! page.broken)
            //dbinterface.pushAnchors (link.getURL(),
            // (link.getPage()).getAnchors());
         }
      } else if (bingoDoc.getStatus() == 'F' || bingoDoc.getStatus() == 'G'
      || bingoDoc.getStatus() == 'D' || bingoDoc.getStatus() == 'R')
      {
         // Frames, Redirs, Google, Google dir
         if (!bingoDoc.isBroken())
         {
            dbinterface.pushLink(bingoDoc);
            dbinterface.pushLinks(bingoDoc.getId(), bingoDoc.getLinks());
         }
      } else if (bingoDoc.getStatus() == 'L' || bingoDoc.getStatus() == 'U')
      {
         // Keine Klassifikation
         if (!bingoDoc.isBroken())
         {
            dbinterface.pushLink(bingoDoc);
            dbinterface.pushNested(bingoDoc);
         }
      }
      destroy();
   }
   //==========================================
   public void destroy()
   {
      super.destroy();
      dbinterface = null;
   }
   public boolean init(URL_Crawler uc, url2resolve u, HttpURLConnection c)
   {
      if (!super.init(uc, u, c))
         return false;
      if (!session.dbConnect)
         return false;
      if (crawler != null)
         dbinterface = crawler.getDBInterface();
      // dbinterface = DBInterface.getInstance();
      if (dbinterface == null || !dbinterface.isValid())
         return false;
      return true;
   }
}
