package bingo.crawler.handler.parser;

import javax.swing.text.MutableAttributeSet;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;

import bingo.util.BingoDocument;
import bingo.util.SessionBuffer;

public class GoogleDirectoryParserCallback extends HTMLEditorKit.ParserCallback {
  boolean flag_cats;
  boolean flag_links;
  BingoDocument bd;


  public GoogleDirectoryParserCallback( BingoDocument bd ) {
    this.bd = bd;
    flag_cats = false;
    flag_links = false;
  }


  public void handleText( char[] data, int pos ) {
    String zeile = String.valueOf( data );

    if ( zeile.toLowerCase().equals( "categories" ) ) {
      flag_cats = true;
    } else if ( zeile.toLowerCase().indexOf( "related categories" ) >= 0 ) {
      flag_cats = false;
    } else if ( zeile.toLowerCase().equals( "web pages" ) ) {
      flag_cats = false;
      flag_links = true;
    }
  }


//=================================================

  public void handleComment( char[] data, int pos ) { }


  public void handleStartTag( HTML.Tag t, MutableAttributeSet a, int pos ) {
    try {
      //URL bearbeiten
      if ( t == HTML.Tag.A && a.getAttribute( HTML.Attribute.HREF ) != null ) {
        if ( flag_cats ) {
          String link = a.getAttribute( HTML.Attribute.HREF ).toString();

          if ( link != null ) {
            bd.addGoogle( new GoogleDirectoryItem( link, true ));
          }
        } else if ( flag_links ) {
          String link = a.getAttribute( HTML.Attribute.HREF ).toString();

          if ( link != null ) {
            if ( link.indexOf( "http://" ) >= 0 && link.indexOf( "google" ) < 0 && link.indexOf( "dmoz" ) < 0 ) {
              bd.addGoogle( new GoogleDirectoryItem( link, false ));
            }
          }
        }
      }
    }
    catch ( Exception e ) {
      SessionBuffer.log(e);
    }
  }


  public void handleEndTag( HTML.Tag t, int pos ) { }


  public void handleSimpleTag( HTML.Tag t, MutableAttributeSet a, int pos ) { }

}
