package bingo.crawler.handler.parser;

import java.util.ArrayList;

import javax.swing.text.MutableAttributeSet;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;

import bingo.util.BingoDocument;
import bingo.util.SessionBuffer;

public class GoogleParserCallback extends HTMLEditorKit.ParserCallback
{
   boolean flag_active;
   boolean flag_category;
   boolean flag_new;
   boolean istFertig;
   int tableDepth;
   
   String act_url;
   GoogleItem ress;
   BingoDocument bd;
   
   static SessionBuffer session;
   
   
   public GoogleParserCallback( BingoDocument bd )
   {
      session = SessionBuffer.getInstance();
      this.bd =bd;
      if (bd.getGoogle() == null)
         bd.setGoogle(new ArrayList(Math.max(session.numGoogleLink, session.numGoogleRelated)));
      flag_active = false;
      tableDepth = 0;
   }
   
   
   public void handleText( char[] data, int pos )
   {
      if ( flag_active )
      {
         String zeile = String.valueOf( data );
         
         if ( zeile.toLowerCase().indexOf( "translate" ) >= 0 )
         {
            // Nicht das Ziel, weil frames - sondern direkt zum translator
            ress.setTranslate( "http://translate.google.com/translate_c?hl=en&sl=de&u=" + ress.getTarget() );
         } else if ( zeile.toLowerCase().indexOf( "cached" ) >= 0 )
         {
            // Google gibt hier relativen Pfad her!!
            ress.setCached( ( "http://www.google.de" ) + act_url );
         } else if ( zeile.toLowerCase().indexOf( "category:" ) >= 0 )
         {
            flag_category = true;
         } else if ( zeile.toLowerCase().indexOf( "similar pages" ) >= 0 )
         {
            flag_new = true;
            if ( ress != null && !ress.getTarget().equals( "none" ) )
            {
               bd.addGoogle( ress );
            }
         }
      }
   }
   
   
   //=================================================
   
   public void handleComment( char[] data, int pos )
   { }
   
   
   public void handleStartTag( HTML.Tag t, MutableAttributeSet a, int pos )
   {
      try
      {
         //Parser init..
         if ( t == HTML.Tag.HTML )
         {
            flag_active = false;
            flag_category = false;
            flag_new = true;
            act_url = "none";
         }
         
         //parser aus..
         if ( a.getAttribute( HTML.Attribute.CLASS ) != null )
         {
            if ( ( t == HTML.Tag.DIV ) && ( a.getAttribute( HTML.Attribute.CLASS ).equals( "nav" ) ) )
            {
               flag_active = false;
            }
            istFertig = true;
         }
         
         if ( t == HTML.Tag.TABLE )
         {
            // in Tabellen gibts nix
            
            flag_active = false;
            tableDepth++;
         }
         
         //URL bearbeiten
         if ( flag_active && t == HTML.Tag.A )
         {
            act_url = ( a.getAttribute( HTML.Attribute.HREF ).toString() );
            if ( flag_new )
            {
               ress = new GoogleItem( act_url );
               flag_new = false;
            } else if ( flag_category )
            {
               ress.setCategory( act_url );
               flag_category = false;
            }
         }
      }
      catch ( Exception e )
      {
         SessionBuffer.log(e);
         flag_active = false;
         flag_category = false;
         flag_new = true;
         act_url = "none";
      }
   }
   
   
   public void handleEndTag( HTML.Tag t, int pos )
   {
      try
      {
         //Parser ein..
         if ( t == HTML.Tag.TABLE )
         {
            tableDepth--;
            if ( tableDepth <= 0 )
            {
               flag_active = true;
            }
         }
         
         if ( t == HTML.Tag.HTML )
         {
            flag_active = false;
            istFertig = true;
         }
      }
      catch ( Exception e )
      {
         SessionBuffer.log(e);
         flag_active = false;
         flag_category = false;
         flag_new = true;
         act_url = "none";
      }
   }
   
   
   public void handleSimpleTag( HTML.Tag t, MutableAttributeSet a, int pos )
   { }
}
