package bingo.crawler.handler.parser;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import bingo.util.BingoDocument;
import bingo.crawler.frontier.url2resolve;
import bingo.crawler.handler.CrawlHandler;
import bingo.util.SessionBuffer;
import java.security.*;

//=======================================================================================

public class PDFParser implements Runnable
{
   SessionBuffer session;
   
   public CrawlHandler parent;
   url2resolve url2r;
   BingoDocument bd = null;
   
   public static String tempPath = "bingo\\crawler\\handler\\temp\\";
   public static String PDF = ".pdf";
   public static String TXT = ".txt";
   public static String progString = "bingo\\crawler\\handler\\FiltDump.bat bingo\\crawler\\handler\\ ";
   
   public static String title = "PDF document";
   
   public static Pattern[] patterns =
   {
      Pattern.compile("<"),
      Pattern.compile("[^\\p{Graph}]"),
      Pattern.compile("\\s++")
   };
   
   public static String[] replaces =
   {
      " ",
      " ",
      " "
   };
   
   public PDFParser( CrawlHandler p, url2resolve u )
   {
      session = SessionBuffer.getInstance();
      parent = p;
      url2r = u;
      bd = u.parentDoc;
      //page = link.getPage();
   }
   
   public void run()
   {
      if (parent.byteArray == null || parent.byteArray.length <= 0 || parent.byteArraySize <= 0 || parent.byteArraySize > parent.byteArray.length)
      {
         bd.setBroken(true);
         destroy();
         return;
      }
      try
      {
         // Zuerst PDF zur konvertierung in Datei speichern
         String nonString = tempPath + bd.getId();
         String pdfString = nonString + PDF;
         String txtString = nonString + TXT;
         
         File file = new File( pdfString );
         FileOutputStream outStream = new FileOutputStream( file );
         outStream.write(parent.byteArray, 0, parent.byteArraySize);
         outStream.flush();
         outStream.close();
         outStream = null; pdfString = null;
         
         //******************************************
         
         Runtime r = Runtime.getRuntime();
         String command = progString + nonString;
         Process prozess = r.exec( command );
         prozess.waitFor();
         int res = prozess.exitValue();
         prozess.getInputStream().close();
         prozess.getOutputStream().close();
         prozess.getErrorStream().close();
         file.delete();
         file = null; prozess = null; command = null;
         r = null; nonString = null;
         
         // Jetzt text wieder einlesen und parsen
         
         if ( res == 0 )
         {
            file = new File( txtString );
            int filesize = (int)file.length();
            if (filesize > 0)
            {
               char[] charArray = new char[filesize];
               FileReader fi = new FileReader(file);
               fi.read(charArray);
               fi.close(); fi=null;
               
               bd.content = charArray;
               bd.contentCounter = filesize-1;
               
               try
               {
                  MessageDigest md = MessageDigest.getInstance("MD5");
                  byte[] hash = md.digest(jodd.util.CharUtil.toByteArray(charArray));
                  if (hash != null && hash.length >=8)
                  {
                     long signature = 0;
                     for (int i=0; i<8; i++)
                     {
                        long tmp = (long)hash[i];
                        tmp = (tmp & 0xff) << (i*8);
                        signature += tmp;
                     }
                     bd.setMD5(signature);
                     
                     //for (int i=0; i<hash.length; i++)
                     //System.out.print("[" + hash[i] + "]") ;
                     //System.out.println();
                  }
                  md=null;
                  hash = null;
               }
               catch (Exception e)
               {
                  e.printStackTrace();
               }
               
               
               // Preview und Title generieren
               bd.setTitle(title);
                   /*
                   int previewLength = Math.min(session.getPreviewLength(), charArray.length);
                   String preview = new String (charArray, 0, previewLength);
                   for (int i=0; i< patterns.length; i++)
                   {
                     Matcher m = patterns[i].matcher(preview);
                     preview = m.replaceAll(replaces[i]);
                     m = null;
                   }
                   bd.setPreview(preview.trim());
                   preview = null;
                    */
               // Terme extrahieren
               StemmerDriver sd = new StemmerDriver();
               LinkedList terms = sd.stem( charArray );
               bd.setText(terms);
               bd.setForeign(sd.isForeign);
               terms=null; charArray=null; sd=null;
            }
            else
               bd.setBroken(true);
            
            file.delete();
            file= null;
         }
         else
            bd.setBroken(true);
         
         txtString = null;
      }
      catch ( Exception e )
      {
         session.log(e);
         bd.setBroken(true);
      }
      
      Vector register = parent.getAssistants();
      if ( register != null )
      {
         synchronized ( register )
         {
            register.remove( this );
            register.notifyAll();
         }
         register = null;
      }
      destroy();
   }
   
   public void destroy()
   {
      session = null;
      url2r = null;
      bd = null;
      parent = null;
   }
}
