package bingo.crawler.handler.parser;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.MalformedURLException;
import java.net.URL;

import org.xml.sax.InputSource;

import bingo.util.SessionBuffer;

public class Source extends InputSource {

  public Source( String s ) {
    super( s );
  }


  public Source( InputStream s ) {
    super( s );
  }


  public Source( Reader r ) {
    super( r );
  }


  public InputStream getByteStream() {
    InputStream stream = super.getByteStream();

    if ( stream == null && getSystemId() != null ) {
      try {
        stream = new URL( getSystemId() ).openStream();
      }
      catch ( MalformedURLException mfe ) {
        SessionBuffer.log(mfe);
      }
      catch ( Exception ioe ) {
        SessionBuffer.log(ioe);
      }
    }
    return stream;
  }


  public Reader getCharacterStream() {
    Reader reader = super.getCharacterStream();

    if ( reader == null && getSystemId() != null ) {
      try {
        reader = new BufferedReader( new InputStreamReader( new URL( getSystemId() ).openStream() ) );
      }
      catch ( MalformedURLException mfe ) {
        SessionBuffer.log(mfe);
      }
      catch ( Exception ioe ) {
        SessionBuffer.log(ioe);
      }
    }
    return reader;
  }


  public void close() throws IOException {
    if ( getByteStream() != null ) {
      getByteStream().close();
    }
    if ( getCharacterStream() != null ) {
      getCharacterStream().close();
    }
  }
}

