package bingo.crawler.handler.parser;

import java.io.Serializable;

public class TextItem implements Serializable, Comparable
{
  // Achtung: Comparable arbeitet hier auf stems !! 
   
  public String term = null;
  public String stem = null;
  
  public int position = 0;
  public boolean isStopword = false;
  
  public TextItem( String t, int p )
  {
    term = t;
    position = p;
  }
  
  public TextItem( String t )
  {
    term = t;
    position = 0;
  }
  
  public int compareTo (Object who)
  {
    if (who == null || ((TextItem)who).stem == null) 
       return +1;
    if (stem == null)
       return -1;
    return stem.compareTo(((TextItem)who).stem);
  }
}
