package bingo.db;

import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JTable;

import bingo.base.BaseFrame;
import bingo.crawler.handler.UrlVerifier;
import bingo.util.BingoDocument;

/**
 *  In dieser Klasse wird ein Thread implementiert, der Eintrge aus der
 *  Datenbank in die Tabelle mit den Trainingsdaten (Klasse "BaseFrame")
 *  transferiert.
 *
 * @author     T
 * @created    15. Juni 2001
 */
public class DBToBaseThread extends Thread {
  private BaseFrame baseFrame;
  private Vector vURLs;


  /**
   *  Konstruktor fr das DBToBaseThread Objekt
   *
   * @param  bf     Der BaseFrame.
   * @param  table  Die Tabelle.
   */
  public DBToBaseThread( BaseFrame bf, JTable table ) {
    this.baseFrame = bf;
    vURLs = new Vector();

    int[] rows = table.getSelectedRows();

    for ( int i = 0; i < rows.length; i++ ) {
      String sURL = (String) table.getValueAt( rows[i], 0 );
      String sNode = (String) table.getValueAt( rows[i], 1 );
      String mime = (String) table.getValueAt( rows[i], 7 );
      Double d = new Double( 0.0 );

      try {
        d = new Double( Double.parseDouble( (String) table.getValueAt( rows[i], 4 ) ) );
      }
      catch ( NumberFormatException ne ) {}

      BingoDocument tmp = UrlVerifier.string2BingoDocument(sURL);
      
      if (tmp==null)
         return;
      
      tmp.setNode(tmp.stringToNode( sNode ));
      tmp.setContentType(mime);
      tmp.setSvmRank( d );
      vURLs.add( tmp );
      tmp = null;
    }
  }


  public DBToBaseThread( BaseFrame bf, Vector vURLs ) {
    this.baseFrame = bf;
    this.vURLs = vURLs;
  }


  /**
   *  Startet den Thread.
   */
  public void run() {

    for ( Enumeration enum = vURLs.elements(); enum.hasMoreElements();  ) {
//      BaseURL temp = (BaseURL) enum.nextElement();

      //try {
/*
        temp.setFeatures( session.dbinterface.pullFeatures( temp.getURL() ) );
        temp.setLinks( session.dbinterface.pullLinks( temp.getURL() ) );
        baseFrame.addNewTableEntry( temp );
*/
      /*}
      catch ( Exception e ) {
        session.log(e);
      }*/

    }
    baseFrame.refreshTable();
  }

}

