package bingo.svmlight;

import java.io.Serializable;

public class Feature implements Serializable, Comparable
{    
    /**
     *  Der betrachtete Term
     */
    public Comparable term;
    
    /**
     *  Der TF Wert (pro Dokument).
     */
    public double TF = 0.0;
    
    
    /**
     *  Generiert eine neues Feature.
     *
     * @param  s   Der Wortstamm.
     * @param  TF  Der TF Wert.
     */
    public Feature( Comparable t, double f)
    {
        term = t;
        TF = f;
    }
    
    
    /**
     *  Liefert den Wortstamm, aus dem dieses Feature gebildet wurde.
     *
     * @return    Der Textterm zu diesem Feature.
     */
    public Comparable getTerm()
    {
        return term;
    }
    
        
    /**
     * @return    Der TF Wert des Features.
     */
    public double getTF()
    {return TF;}
    
    
    /**
     * @param  d  Der neue TF-Wert.
     */
    public void setTF( double d )
    {TF = d;}
    
    public double getWeight()
    {return TF;}
    
    public int compareTo( Object o )
    {
        Comparable who = ((Feature)o).getTerm();
        return this.getTerm().compareTo (who);
    }   
}