package bingo.svmlight;

import javax.swing.tree.DefaultMutableTreeNode;

/**
 *  Listener-Interface zur Ausgabe von Ereignissen, die das Objekt
 *  SVMModelBuilder generiert.
 *
 * @author     T
 * @created    15. Juni 2001
 */

public interface SVMModelListener {

  /**
   *  Fortschritt.
   *
   * @param  value  Neuer Wert des JProgressBars.
   * @param  node   Aktueller Kategorieknoten.
   */
  void barChanged( int value, DefaultMutableTreeNode node );


  /**
   *  Trainingsdaten werden als "positives" Beispiel dem Modell zugeordnet.
   *
   * @param  sample   Beschreibung.
   * @param  comment  Ein Kommentar.
   */
  void positiveSample( String sample, String comment );


  /**
   *  Trainingsdaten werden als "negatives" Beispiel dem Modell zugeordnet.
   *
   * @param  sample   Beschreibung.
   * @param  comment  Ein Kommentar.
   */
  void negativeSample( String sample, String comment );


  /**
   *  Es wird ein neuer Knoten innerhalb der Hierarchie betrachtet.
   *
   * @param  n  Der neue Kategorieknoten.
   */
  void nodeChanged( DefaultMutableTreeNode n );


  /**
   *  Modellierung abgeschlossen.
   *
   * @param  comment  Ein Kommentar.
   */
  void finished( String comment );


  /**
   *  Behandelt eine Exception.
   *
   * @param  e  Die Exception.
   */
  void handleException( Exception e );
  
  void warning (String text);
  
  void message (String text);

}

