package bingo.svmlight;

import java.util.Vector;

import javax.swing.tree.DefaultMutableTreeNode;

/**
 *  Listener-Interface zur Ausgabe von Ereignissen die der SVMTreeClassifier
 *  generiert..
 *
 * @author     T
 * @created    15. Juni 2001
 */

public interface SVMTreeListener {

  /**
   *  Ein Dokument wird dem aktuellen Knoten im Hierachiebaum als zugehrig
   *  klassifiziert.
   *
   * @param  d        Description of Parameter
   * @param  n        Description of Parameter
   * @param  comment  Description of Parameter
   */
  void classified( double d, DefaultMutableTreeNode n, String comment );


  /**
   *  Ein Dokument wird dem aktuellen Knoten im Hierachiebaum als nicht
   *  zugehrig klassifiziert.
   *
   * @param  d        Description of Parameter
   * @param  n        Description of Parameter
   * @param  comment  Description of Parameter
   */

  void notClassified( double d, DefaultMutableTreeNode n, String comment );


  /**
   *  Es wird ein neuer Knoten innerhalb der Hierarchie betrachtet.
   *
   * @param  n  Description of Parameter
   */
  void nodeChanged( DefaultMutableTreeNode n );


  /**
   *  Hierarchische Klassifikation des Dokuments abgeschlossen.
   *
   * @param  v        Description of Parameter
   * @param  n        Description of Parameter
   * @param  comment  Description of Parameter
   */
  void finished( Vector v, DefaultMutableTreeNode n, String comment );


  /**
   *  Behandelt eine Exception.
   *
   * @param  e  Description of Parameter
   */
  void handleException(Exception e);

}

