package bingo.svmlight;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Collection;
import java.util.LinkedList;

import bingo.crawler.handler.parser.TextItem;

public class TFBuilder
{
   public static LinkedList getTFFeatures( Collection textItems )
   {
      if (textItems == null)
         return null;
      if (textItems.size() <= 0)
         return new LinkedList();
      
      Object[] items = textItems.toArray();
      LinkedList result = getTFFeatures( items );
      items = null;
      return result;
   }
   
   public static LinkedList getTFFeatures( Object[] items )
   {
      Arrays.sort(items);
      LinkedList resultKette = new LinkedList();
      int currentPos = 0;
      double currentCount = 1.0;
      for (int i=1; i<items.length;i++)
      {
         if ( ((TextItem)items[currentPos]).stem.compareTo(((TextItem)items[i]).stem) == 0)  // equal
            currentCount += 1.0;
         else
         {
            resultKette.add(0, new Feature(((TextItem)items[currentPos]).stem, currentCount ));
            currentPos = i;
            currentCount = 1.0;
         }
      }
      // den letzten nicht vergessen
      resultKette.add(0, new Feature(((TextItem)items[currentPos]).stem, currentCount ));
      items = null;
      
      return resultKette;
   }
   
   public static double getMaxTF( Collection f)
   {
      if (f == null)
         return -1.0;
      
      if (f.size() == 0)
         return 0.0;
      
      Object[] features = f.toArray();
      Arrays.sort(features);
      double result = ((Feature)features[features.length - 1]).getWeight();
      features = null;
      return result;
   }
}