/*
 * Created on 27.02.2004
 *
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package bingo.util;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;
import java.net.*;
import java.security.*;

import bingo.crawler.LinkEvent;
import bingo.crawler.frontier.url2resolve;
import bingo.crawler.handler.parser.TextItem;
/**
 * @author kaster
 *
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
// URL base?? toUrl?
public class BingoDocument implements Serializable
{
   // Objekte aus BaseURL
   // private ArrayList anchors;
   private Collection featureVector = null;
   private ArrayList google = null;
   private LinkedList links;
   private LinkedList text = null;
   private BingoTreeNode node;
   private boolean broken = false;
   private boolean hasFeaturesInDB = false;
   private boolean hasForms = false;
   private boolean hasFrames = false;
   private boolean isCached = false;
   private byte[] bulk = null;
   private char status;
   private Double svmRank = null;
   private float priority;
   private int bulkSize = 0;
   private int classDistance = 0;
   private int contentLength = -1;
   private int depth; // Tiefe des BingoDocuments
   private int eventStatus = LinkEvent.NONE;
   private int hops = 0; // Anzahl redirects in Kette, 0 fuer normale Seiten
   public long id = 0;
   private long parentID = 0; // ID des Vorgaengers
   private int responseCode = -1;
   private int wormID;
   private long expiration = 0;
   private long lastModified = 0;
   private Object[] mappedFeatures = null;
   private String contentEncoding = null;
   private String contentType = null;
   private String directory = null;
   private String filename = null;
   private String host = null;
   private String preview = null;
   private boolean containsRedirect = false;
   private String responseMessage = null;
   private String sourceLink = null;
   private String title = null;
   private String url = null;
   private url2resolve url2r = null;
   private long md5;
   private long parsedBefore = (long)0;
   
   private boolean isForeign = false;
   
   public boolean fromFrame = false;
   public BingoTreeNode fromNode = null;
   
   public char[] content = null;
   public int contentCounter = 0;
   
   //Konstruktoren
   /**
    * Generiert ein neues BingoDocument mit angegebener URL und zugehrigem
    * Baumknoten als Kategorie. Aus dem Knoten wird eine Stringdarstellung des
    * Kategoriepfades generiert.
    *
    * @param sURL
    *            vorgegebene URL
    * @param dmtn
    *            Baumknoten
    */
   public BingoDocument(String url, BingoTreeNode n)
   {
      this.url = url;
      this.node = n;
      this.contentType = null;
      this.md5 = 0;
      this.setStatus('L');
   }
   
   public BingoDocument()
   {
      SessionBuffer s = SessionBuffer.getInstance();
      this.node = s.getRootNode();
      this.contentType = null;
      this.md5 = 0;
      this.setStatus('L');
   }
   
   /* Set the md5 signature of this tocument to the given value
    * @param value The new MD5 signature of the document
    */
   public void setMD5(long value)
   {
      this.md5 = value;
   }
   
   /* Returns the md5 signature of the tocument
    * @return The MD5 signature of the document
    */
   public long getMD5()
   {
      return this.md5;
   }
   
   /** ID, unter der ein identisches Dokument zuvor geparst wurde
    * @return die ID des identischen Dokuments, das zuvor geparst wurde
    */
   public long getParsedBefore()
   {
      return parsedBefore;
   }
   
   /* Dokument als Duplikat des frher geparsten vormerken und seine ID speichern
    * @param val die ID des zuvor geparsten identischen Dokuments
    */
   public void setParsedBefore(long val)
   {
      this.parsedBefore = val;
   }
   
   /**
    * Testet, ob diese BaseURL einen FeatureVector besitzt.
    *
    * @return Ergebnis des Tests als String
    */
   public boolean hasFeatureV()
   {
      return (featureVector != null && featureVector.size() > 0);
   }
   /**
    * Lscht den Parsed-Vektor dieser BaseURL und spart Speicher.
    */
   public void discardContent()
   {
      this.text = null;
      this.links = null;
      // this.anchors = null;
   }
   public static String nodeToString(BingoTreeNode node)
   {
      return node.label;
   }
   public static BingoTreeNode stringToNode(String who)
   {
      BingoTreeNode rootNode = SessionBuffer.getInstance().getRootNode();
      if (rootNode == null)
         return null;
      return (BingoTreeNode) rootNode.allClasses.get(who);
   }
   
   public static String relativeTo( String here, String there )
   {
      StringBuffer result = new StringBuffer();
      
      int lcp = 0;
      
      while ( true )
      {
         int i = here.indexOf( '/', lcp );
         int j = there.indexOf( '/', lcp );
         
         if ( i == -1 || i != j || !here.regionMatches( lcp, there, lcp, i - lcp ) )
         {
            break;
         }
         lcp = i + 1;
      }
      
      for ( int i = here.indexOf( '/', lcp );
      i != -1;
      i = here.indexOf( '/', i + 1 ) )
      {
         result.append( ".." );
         result.append( '/' );
      }
      
      result.append( there.substring( lcp ) );
      
      return result.toString();
   }
   
   public void addText(TextItem t)
   {
      if (text == null)
         return;
      if (t != null)
         text.add(t);
   }
   
   public boolean addLink(URL newlink)
   {
      if (newlink == null)
         return false;
      
      if (links == null)
         links = new LinkedList();
      
      if (!links.contains(newlink))
      {         
        links.add(newlink);
        return true;
      }
      else
        return false;
   }
   
   public void addGoogle(Object g)
   {
      if (google == null)
         return;
      
      if (g != null)
         google.add(g);
   }
   
   // Getter und Setter
   
   /**
    * Testet, ob die Seite geparst wurde.
    *
    * @return Der Wert.
    */
   public boolean isParsed()
   {
      return (text != null);
   }
   /**
    * Liefert die Tiefe der Seite im Crawling-Graphen.
    *
    * @return Die Tiefe vom Startlink aus.
    */
   public int getDepth()
   {
      return depth;
   }
   
   public void setDepth(int depth)
   {
      this.depth = depth;
   }
   
   
   
   /**
    * @return Returns the anchors.
    */
   public ArrayList getAnchors()
   {
      // return anchors;
      return null;
   }
   /**
    * @param anchors
    *            The anchors to set.
    */
   public void setAnchors(ArrayList anchors)
   {
      // this.anchors = anchors;
   }
   /**
    * @return Returns the broken.
    */
   public boolean isBroken()
   {
      return broken;
   }
   /**
    * @param broken
    *            The broken to set.
    */
   public void setBroken(boolean broken)
   {
      this.broken = broken;
   }
   /**
    * @return Returns the bulk.
    */
   public byte[] getBulk()
   {
      return bulk;
   }
   /**
    * @param bulk
    *            The bulk to set.
    */
   public void setBulk(byte[] bulk)
   {
      this.bulk = bulk;
   }
   /**
    * @return Returns the bulkSize.
    */
   public int getBulkSize()
   {
      return bulkSize;
   }
   /**
    * @param bulkSize
    *            The bulkSize to set.
    */
   public void setBulkSize(int bulkSize)
   {
      this.bulkSize = bulkSize;
   }
   /**
    * @return Returns the classDistance.
    */
   public int getClassDistance()
   {
      return classDistance;
   }
   /**
    * @param classDistance
    *            The classDistance to set.
    */
   public void setClassDistance(int classDistance)
   {
      this.classDistance = classDistance;
   }
   
   /*	*//**
    * @return Returns the classifiedNode.
    *//*
        public BingoTreeNode getClassifiedNode() {
                return classifiedNode;
        }*/
   
   /**
    * @param classifiedNode
    *            The classifiedNode to set.
    */
/*	public void setClassifiedNode(BingoTreeNode classifiedNode) {
                this.classifiedNode = classifiedNode;
        }
 */	/**
  * @return Returns the contentEncoding.
  */
   public String getContentEncoding()
   {
      return contentEncoding;
   }
   /**
    * @param contentEncoding
    *            The contentEncoding to set.
    */
   public void setContentEncoding(String contentEncoding)
   {
      this.contentEncoding = contentEncoding;
   }
   /**
    * @return Returns the contentLength.
    */
   public int getContentLength()
   {
      return contentLength;
   }
   /**
    * @param contentLength
    *            The contentLength to set.
    */
   public void setContentLength(int contentLength)
   {
      this.contentLength = contentLength;
   }
   /**
    * @return Returns the contentType.
    */
   public String getContentType()
   {
      return contentType;
   }
   /**
    * @param contentType
    *            The contentType to set.
    */
   public void setContentType(String contentType)
   {
      this.contentType = contentType;
   }
   /**
    * @return Returns the directory.
    */
   public String getDirectory()
   {
      return directory;
   }
   /**
    * @param directory
    *            The directory to set.
    */
   public void setDirectory(String directory)
   {
      this.directory = directory;
   }
   /**
    * @return Returns the eventStatus.
    */
   public int getEventStatus()
   {
      return eventStatus;
   }
   /**
    * @param eventStatus
    *            The eventStatus to set.
    */
   public void setEventStatus(int eventStatus)
   {
      this.eventStatus = eventStatus;
   }
   /**
    * @return Returns the expiration.
    */
   public long getExpiration()
   {
      return expiration;
   }
   /**
    * @param expiration
    *            The expiration to set.
    */
   public void setExpiration(long expiration)
   {
      this.expiration = expiration;
   }
   /**
    * @return Returns the featureVector.
    */
   public Collection getFeatureVector()
   {
      return featureVector;
   }
   /**
    * @param featureVector
    *            The featureVector to set.
    */
   public void setFeatureVector(Collection featureVector)
   {
      this.featureVector = featureVector;
   }
   /**
    * @return Returns the filename.
    */
   public String getFilename()
   {
      return filename;
   }
   /**
    * @param filename
    *            The filename to set.
    */
   public void setFilename(String filename)
   {
      this.filename = filename;
   }
   /**
    * @return Returns the google.
    */
   public ArrayList getGoogle()
   {
      return google;
   }
   /**
    * @param google
    *            The google to set.
    */
   public void setGoogle(ArrayList google)
   {
      this.google = google;
   }
   /**
    * @return Returns the hasFeaturesInDB.
    */
   public boolean hasFeaturesInDB()
   {
      return hasFeaturesInDB;
   }
   /**
    * @param hasFeaturesInDB
    *            The hasFeaturesInDB to set.
    */
   public void setHasFeaturesInDB(boolean hasFeaturesInDB)
   {
      this.hasFeaturesInDB = hasFeaturesInDB;
   }
   /**
    * @return Returns the hasFrames.
    */
   public boolean hasFrames()
   {
      return hasFrames;
   }
   /**
    * @param hasFrames
    *            The hasFrames to set.
    */
   public void setHasFrames(boolean hasFrames)
   {
      this.hasFrames = hasFrames;
   }
   /**
    * @return Returns the hops.
    */
   public int getHops()
   {
      return hops;
   }
   /**
    * @param hops
    *            The hops to set.
    */
   public void setHops(int hops)
   {
      this.hops = hops;
   }
   /**
    * @return Returns the host.
    */
   public String getHost()
   {
      return host;
   }
   /**
    * @param host
    *            The host to set.
    */
   public void setHost(String host)
   {
      this.host = host;
   }
   /**
    * @return Returns the id.
    */
   public long getId()
   {
      if (id == 0)
         setID();
      return id;
   }
   /*	*//**
    * @param id
    *            The id to set.
    */
        /*
         * public void setId(int id) { this.id = id;
         */
   /**
    * @return Returns the isCached.
    */
   public boolean isCached()
   {
      return isCached;
   }
   /**
    * @param isCached
    *            The isCached to set.
    */
   public void setCached(boolean isCached)
   {
      this.isCached = isCached;
   }
   /**
    * @return Returns the lastModified.
    */
   public long getLastModified()
   {
      return lastModified;
   }
   /**
    * @param lastModified
    *            The lastModified to set.
    */
   public void setLastModified(long lastModified)
   {
      this.lastModified = lastModified;
   }
   /**
    * @return Returns the links.
    */
   public LinkedList getLinks()
   {
      return links;
   }
   /**
    * @param links
    *            The links to set.
    */
   public void setLinks(LinkedList links)
   {
      this.links = links;
   }
   /**
    * @return Returns the mappedFeatures.
    */
   public Object[] getMappedFeatures()
   {
      return mappedFeatures;
   }
   /**
    * @param mappedFeatures
    *            The mappedFeatures to set.
    */
   public void setMappedFeatures(Object[] mappedFeatures)
   {
      this.mappedFeatures = mappedFeatures;
   }
   /**
    * @return Returns the node.
    */
   public BingoTreeNode getNode()
   {
      return node;
   }
   
   /**
    * @param node
    *            The node to set.
    */
   public void setNode(BingoTreeNode node)
   {
      this.node = node;
   }
   /**
    * @return Returns the parentID.
    */
   public long getParentID()
   {
      return parentID;
   }
   /**
    * @param parentID
    *            The parentID to set.
    */
   public void setParentID(long p)
   {
      this.parentID = p;
   }
   /**
    * @return Returns the preview.
    */
   public String getPreview()
   {
      return preview;
   }
   /**
    * @param preview
    *            The preview to set.
    */
   public void setPreview(String preview)
   {
      this.preview = preview;
   }
   /**
    * @return Returns the priority.
    */
   public float getPriority()
   {
      return priority;
   }
   /**
    * @param priority
    *            The priority to set.
    */
   public void setPriority(float priority)
   {
      this.priority = priority;
      if (this.url2r != null)
      {
         this.url2r.setPrio(priority);
      }
   }
   /**
    * @return Returns the redirect.
    */
   public boolean hasRedirect()
   {
      return containsRedirect;
   }
   /**
    * @param redirect
    *            The redirect to set.
    */
   public void setRedirect(boolean redirect)
   {
      this.containsRedirect = redirect;
   }
   /**
    * @return Returns the responseCode.
    */
   public int getResponseCode()
   {
      return responseCode;
   }
   /**
    * @param responseCode
    *            The responseCode to set.
    */
   public void setResponseCode(int responseCode)
   {
      this.responseCode = responseCode;
   }
   /**
    * @return Returns the responseMessage.
    */
   public String getResponseMessage()
   {
      return responseMessage;
   }
   /**
    * @param responseMessage
    *            The responseMessage to set.
    */
   public void setResponseMessage(String responseMessage)
   {
      this.responseMessage = responseMessage;
   }
   /**
    * @return Returns the rootNode.
    */
/*	public BingoTreeNode getRootNode() {
                return rootNode;
        }
 */	/**
  * @param rootNode
  *            The rootNode to set.
  */
/*	public void setRootNode(BingoTreeNode rootNode) {
                this.rootNode = rootNode;
        }
 */	/**
  * @return Returns the sourceLink.
  */
   public String getSourceLink()
   {
      return sourceLink;
   }
   /**
    * @param sourceLink
    *            The sourceLink to set.
    */
   public void setSourceLink(String sourceLink)
   {
      this.sourceLink = sourceLink;
   }
   /**
    * @return Returns the status.
    */
   public char getStatus()
   {
      return status;
   }
   /**
    * @param status
    *            The status to set.
    */
   public void setStatus(char status)
   {
      this.status = status;
   }
        /*
         *//**
          * @return Returns the sURL.
          */
        /*
         * public String getSURL() { return sURL; }
         *
         *//**
          * @param surl
          *            The sURL to set.
          */
        /*
         * public void setSURL(String surl) { sURL = surl; }
         */
   /**
    * @return Returns the svmRank.
    */
   public Double getSvmRank()
   {
      if (svmRank == null)
         return new Double(0.0);
      
      return svmRank;
   }
   /**
    * @param svmRank
    *            The svmRank to set.
    */
   public void setSvmRank(Double svmRank)
   {
      this.svmRank = svmRank;
   }
   /**
    * @return Returns the text.
    */
   public LinkedList getText()
   {
      return text;
   }
   /**
    * @param text
    *            The text to set.
    */
   public void setText(LinkedList text)
   {
      this.text = text;
   }
   /**
    * @return Returns the title.
    */
   public String getTitle()
   {
      return title;
   }
   /**
    * @param title
    *            The title to set.
    */
   public void setTitle(String title)
   {
      this.title = title;
   }
   /**
    * @return Returns the url.
    */
   public String getUrl()
   {
      return url;
   }
   /**
    * @param url
    *            The url to set.
    */
   
   /**
    * @return Returns the url2r.
    */
   public url2resolve getUrl2r()
   {
                /*
                 * if (url2r == null)
                 */
      return url2r;
   }
   /**
    * @param url2r
    *            The url2r to set.
    */
   public void setUrl2r(url2resolve u)
   {
      this.url2r = u;
      if (url2r == null)
         return;
      
      url2r.parentDoc = this;
      if (url2r.isBad())
         return;
      
      try
      {
         this.url = (u.getHost() + u.getFile()).toLowerCase().trim();
      }
      catch (Exception e)
      {
         this.url = null;
      }
      
      setID();
   }
   
   public void setURL(String toSet)
   {
      url = toSet.toLowerCase().trim();
      id = url.hashCode();
   }
   
   /**
    * @return Returns the wormID.
    */
   public int getWormID()
   {
      return wormID;
   }
   /**
    * @param wormID
    *            The wormID to set.
    */
   public void setWormID(int wormID)
   {
      this.wormID = wormID;
   }
   
   
   /**
    * @param hasForms
    *            The hasForms to set.
    */
   public void setHasForms(boolean hasForms)
   {
      this.hasForms = hasForms;
   }
   public boolean hasForms()
   {
      return hasForms;
   }
   public String getClassString()
   {
                /*if (classifiedNode != null)
                        return classifiedNode.label;
                else*/
      return node.label; // TODO: stimmt das noch?? vorher return null braucht man die classified node?
   }
   
   public static long getID(String who)
   {
      long signature = 0;
      try
      {
         // id = url.hashCode();
         // Neuerung: MD5-Signatur statt HashCode()
         MessageDigest md = MessageDigest.getInstance("MD5");
         byte[] hash = md.digest(jodd.util.CharUtil.toByteArray(who.toCharArray()) );
         if (hash != null && hash.length >=8)
         {
            for (int i=0; i<8; i++)
            {
               long tmp = (long)hash[i];
               tmp = (tmp & 0xff) << (i*8);
               signature += tmp;
            }
         }
         md=null;
         hash = null;
      }
      catch (Exception e)
      {
         e.printStackTrace();
         signature = 0;
      }
      return signature;
   }
   
   
   private void setID()
   {
      if (url == null || url.length() <= 0)
         id = 0;
      else
         id = getID(url);
   }
   
   // TODO: Methode checken. title vs. link.text
   public String toDescription()
   {
      return url;
      //return (title.length() > 0 ? title + " " : "") + "[" + getUrl() + "]";
   }
   
   public boolean isForeign()
   {
     return isForeign;
   }

   public void setForeign(boolean b)
   {
     isForeign = b;
   }
   
}