/*
 * DummyHttpURLConnection.java
 *
 * Created on 8. Oktober 2002, 11:04
 */
package bingo.util;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

import bingo.crawler.handler.UrlVerifier;

/**
 * Replacement for HttpURLConnection with a given Content-String!
 *
 * @author     T
 * @created    19. August 2003
 */

public class DummyHttpURLConnection extends HttpURLConnection {

  private URL url;
  private String content;


  public DummyHttpURLConnection( URL url, String content ) {
    super( url );
    this.url = url;
    this.content = content;
  }


  public DummyHttpURLConnection( URL url ) {
    super( url );
    this.url = url;
    this.content = readURL( url.toString() );
  }


  public String getContentType() {
    UrlVerifier uv = new UrlVerifier( null );

    return uv.guessContentTypeFromName( url.toString() );
  }


  public InputStream getInputStream() throws IOException {
    return new ByteArrayInputStream( content.getBytes() );
  }


  public boolean usingProxy() {
    return false;
  }


  public void disconnect() {
  }


  public void connect() {
  }


  public int getResponseCode() throws IOException {
    if ( content == null || content.length() == 0 ) {
      return HttpURLConnection.HTTP_NO_CONTENT;
    }
    return HttpURLConnection.HTTP_OK;
  }


  public String toString() {
    return "DUMMYCONNECTION on " + url.toString();
  }


  public static String readURL( String url ) {
    int iZeichen;
    StringBuffer sb = new StringBuffer();

    try {
      URL sourceURL = new URL( url );
      BufferedReader reader = new BufferedReader( new InputStreamReader( sourceURL.openStream() ) );

      while ( ( iZeichen = reader.read() ) != -1 ) {
        sb.append( (char) iZeichen );
      }
      reader.close();
    }
    catch ( Exception e ) {
      sb = new StringBuffer();
    }
    return sb.toString();
  }

}
