/*
 * SeedCheck.java
 *
 * Created on 4. September 2003, 10:14
 */

package bingo.util;

import java.io.File;
import java.io.FileWriter;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 * Diese Klasse speichert eine Liste der eingelesenen Start-URL's in eine
 * Text-Datei. Die Liste ist alphabetisch aufsteigend sortiert.
 * Dient zum Debugging...
 *
 * @author  kaster
 */
public class SeedCheck {
    
    private static SessionBuffer session = SessionBuffer.getInstance();
    
    
    public static void storeSeed() {
        try {
            SessionBuffer.log("SeedCheck aufgerufen!", 3);
            Connection con = session.getDBConnection();
            Statement stmt = con.createStatement();
            
            // wieviel Trainingsdokumente stehen in bingodocuments?
            String sql = "SELECT COUNT(*) FROM bingodocuments";
            ResultSet res = stmt.executeQuery(sql);
            res.next();
            int size = res.getInt(1);
            
            // Initialisiere StringBuffer mit der Anzahl der Eintrge
            StringBuffer buffi = new StringBuffer(size*2);
            
            // Lese URL's aus...
            sql = "SELECT url FROM bingodocuments ORDER BY url ASC";
            res = stmt.executeQuery(sql);
            
            while (res.next()) {
                buffi.append(res.getString("url"));
                buffi.append("\n");
            }
            
            // Schliesse die DB-Verbindungen
            res.close();
            stmt.close();
            con.close();
            
            long timestamp = System.currentTimeMillis();
            String userdir = System.getProperty("user.dir");
            String s = System.getProperty("file.separator");
            File file = new File(userdir + s + "seed" + timestamp + ".txt");
            FileWriter writer = new FileWriter(file);
            writer.write(buffi.toString());
            writer.flush();
            SessionBuffer.log("CrawlSeed stored in " + file.getPath() + file.getName(), 3);
        } catch (Exception e) {
            session.log(e);
        }
    }
    
}
