package bingo.util;

/**
 *  Spezieller Tokenizer fr Character-Arrays oder Strings, der nur vollstndige
 *  Folgen von chars bercksichtigt, fr die Character.isLetter wahr ist.
 *
 * @author     T
 * @created    15. Juni 2001
 */
public class Tokenizer {
  private char[] data;
  private int pos;


  /**
   *  Konstruktor fr das Tokenizer Objekt
   *
   * @param  s  Der String.
   */
  public Tokenizer( String s ) {
    this.data = s.toCharArray();
    pos = 0;
  }


  /**
   *  Konstruktor fr das Tokenizer Objekt
   *
   * @param  w  Eingabefeld von chars.
   */
  public Tokenizer( char[] w ) {
    this.data = w;
    pos = 0;
  }


  /**
   *  True, solange es mehr Tokens gibt. Sonst false.
   *
   * @return    Der Wert.
   */
  public boolean hasMoreTokens() {
    if ( data == null || pos >= data.length - 1 ) {
      return false;
    } else {
      return true;
    }
  }


  /**
   *  Das nchste Token. Ergebnis ist immer eine vollstndige Folge von
   *  Character.isLetter Zeichen.
   *
   * @return    Das Token.
   */
  public String nextToken() {
    String result = "";

    while ( pos < data.length && Character.isISOControl( data[pos] ) ) {
      pos++;
    }
    if ( pos < data.length && !Character.isLetter( data[pos] ) && !Character.isDigit( data[pos] ) ) {
      result += data[pos];
      pos++;
    }
    if ( result.equals( "" ) ) {
      while ( pos < data.length && Character.isLetter( data[pos] ) ) {
        result += data[pos];
        pos++;
        if ( pos >= data.length ) {
          break;
        }
      }
    }
    if ( result.equals( "" ) ) {
      while ( pos < data.length && Character.isDigit( data[pos] ) ) {
        result += data[pos];
        pos++;
      }
    }
    return result;
  }
}

