package multivalent.net;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Map;
import java.util.HashMap;

import multivalent.*;



/**
	Intercepts openDocument events with "about" protocol and remaps to document as given in attributes.

	@version $Revision: 1.3 $ $Date: 2003/06/02 05:22:03 $
*/
public class About extends Behavior {
  public static final String ATTR_MAP = "map";

  Map<String,String> remap_ = new HashMap<String,String>(20); 	// about:<name> mapped to URI via attributes in a hub

  public boolean semanticEventAfter(SemanticEvent se, String msg) {
//System.out.println("About behavior with "+msg);
	if (super.semanticEventBefore(se,msg)) return true;

	Object arg = se.getArg();
	if (Document.MSG_OPEN==msg && arg instanceof URI) {
		URI uri = (URI)arg;

		if ("about".equals(uri.getScheme())) {
			URI ruri = null;    //l = getClass().getResource("About.html");
			String redirect = remap_.get(uri.getSchemeSpecificPart().toLowerCase());
//System.out.println("|"+uri.getSchemeSpecificPart()+"| => "+redirect);
			if (redirect!=null) try { ruri = new URI(redirect); } catch (URISyntaxException e) {}

			Browser br = getBrowser();
			br.eventq(Document.MSG_OPEN, ruri);
//System.out.println("cancelling in About");
			return true;
		}
	}
	return false;
  }

  /** Take about name-to-URI remappings from MAP attribute of <name> <uri>, <name2> <uri2> ... pairings. */
  public void restore(ESISNode n, Map<String,Object> attr, Layer layer) {
	super.restore(n,attr,layer);

	String[] map = getAttr(ATTR_MAP, "").split(",");
	for (int i=0,imax=map.length; i<imax; i++) {
		String nameval = map[i].trim();
		int inx = nameval.indexOf(' ');
		if (inx!=-1) remap_.put(nameval.substring(0,inx).trim().toLowerCase(), nameval.substring(inx+1).trim());
	}
  }
}
