package schema;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.sql.Connection;
import java.sql.Statement;
import java.util.*;
import bingo.util.Account;

public class SchemaManager
{
   private SessionBuffer session;
   private Connection conn;
   private Statement stmt;
   
   public SchemaManager()
   {
      session = SessionBuffer.getInstance(true);
   }
   
   public void createSchema()
   {
      try
      {
         openAdminConnection();
         
         processFile(session.userDir + System.getProperty( "file.separator" ) + "schema" + System.getProperty( "file.separator" ) + "user.sql");
         closeConnection();
         
         openConnection();
         processFile(session.userDir + System.getProperty( "file.separator" ) + "schema" + System.getProperty( "file.separator" ) + "schema_speed.sql");
         closeConnection();
         
         storeDescriptor();
      }
      catch (Exception e)
      {e.printStackTrace();}
   }
   
   public void createIndex()
   {
      try
      {
         openConnection();
         processFile(session.userDir + System.getProperty( "file.separator" ) + "index.sql");
         closeConnection();
      }
      catch (Exception e)
      {e.printStackTrace();}
   }
   
   public void processFile(String myFile) throws Exception
   {
      BufferedReader reader = new BufferedReader(new FileReader(new File(myFile)));
      boolean finished = false;
      
      StringBuffer command = new StringBuffer();
      while (! finished)
      {
         String line = reader.readLine();
         if (line == null)
         {
            if (command.length() > 0)
            {
               String befehl = command.toString().replaceAll(";","");
               try
               {stmt.executeQuery(befehl);}
               catch (Exception e)
               {e.printStackTrace();}
               System.out.println(befehl);
               befehl = null;
               command = null;
            }
            finished = true;
         }
         else if (line.trim().length() == 0 || line.startsWith("--"))
         {
            if (command.length() > 0)
            {
               String befehl = command.toString().replaceAll(";","");
               try
               {stmt.executeQuery(befehl);}
               catch (Exception e)
               {
                  e.printStackTrace();
               }
               System.out.println(befehl);
               befehl = null;
               command = new StringBuffer();
            }
         }
         else
         {
            line = line.replaceAll("\\$user\\$", session.defaultUser);
            line = line.replaceAll("\\$password\\$", session.defaultUserPasswd);
            command.append(line);
            command.append(" ");
         }
      }
      
   }
   
   public void DropSchema()
   {
      
   }
   
   public void dropIndex()
   {
      
   }
   
   void closeConnection()
   {
      if (stmt != null)
         try
         {stmt.close();}
         catch (Exception e)
         {}
      stmt=null;
      
      if (conn != null)
         try
         {conn.close();}
         catch (Exception e)
         {}
      conn=null;
   }
   
   void openConnection()
   {
      try
      {
         conn= session.getOracleConnection();
         stmt = conn.createStatement();
      }
      catch (Exception e)
      {e.printStackTrace();}
   }
   
   void openAdminConnection()
   {
      try
      {
         conn= session.getAdminOracleConnection();
         stmt = conn.createStatement();
      }
      catch (Exception e)
      {e.printStackTrace();}
   }
   
   void storeDescriptor() throws Exception
   {
      TreeSet existing = LoginDialog.readAccounts();
      Account newAccount = new Account();
      
      newAccount.user = session.defaultUser;
      newAccount.pass = session.defaultUserPasswd;
      newAccount.host = session.sHost;
      newAccount.nsid = session.sServiceName;
      
      String s = System.getProperty( "file.separator" );
      File file = new File(session.userDir + s + "bingo" + s + "data" + s + "accounts.dat");
      //String descriptor = session.defaultUser + ";" + session.defaultUserPasswd + ";" + session.sHost + ";" + session.sServiceName;
      BufferedWriter to;
      
      if (file.exists())
         file.delete();
      
      //File tmp = new File (session.userDir + s + "bingo" + s + "data" + s + "accounts.tmp");
      //file.renameTo (tmp);
      //file = new File (session.userDir + s + "bingo" + s + "data" + s + "accounts.dat");
      //BufferedReader from = new BufferedReader (new FileReader (tmp));
      to = new BufferedWriter(new FileWriter(file));
      
      String line = null;
      
      Iterator it = existing.iterator();
      while (it.hasNext())
      {
         Account acc = (Account)it.next();
         if (acc.compareTo(newAccount) != 0)
         {
            if (acc.user.trim().length() > 0 || acc.pass.trim().length() > 0 || acc.host.trim().length() > 0 || acc.nsid.trim().length() > 0)
            {   
              line = acc.user + ";" + acc.pass + ";" + acc.host + ";" + acc.nsid;
              to.write(line);
              to.newLine();
            }  
         }
      }
      line = newAccount.user + ";" + newAccount.pass + ";" + newAccount.host + ";" + newAccount.nsid;
      to.write(line); to.newLine();
      to.flush(); to.close(); to = null;
      line = null;
   }
   
   public static void main(String[] s)
   {
      new SchemaManager().createSchema();
      System.exit(0);
   }
}
