package schema;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.sql.Connection;
import java.sql.Statement;

public class SchemaManagerMysql
{   
    private SessionBufferMysql session;
    private Connection conn;
    private Statement stmt;

    public SchemaManagerMysql()
    {
      session = SessionBufferMysql.getInstance(true);
    }
    
    public void createSchema ()
    {
      try
      {
        openAdminConnection();  
        
        processFile (session.userDir + System.getProperty( "file.separator" ) + "schema" + System.getProperty( "file.separator" ) + "user_mysql.sql");
        closeConnection();
        
        openConnection();  
        processFile (session.userDir + System.getProperty( "file.separator" ) + "schema" + System.getProperty( "file.separator" ) + "schema_speed_mysql.sql");
        closeConnection();
        
        storeDescriptor();
      } 
      catch (Exception e)
      {e.printStackTrace();}
    }

    public void createIndex ()
    {
      try
      {        
        openConnection();  
        processFile (session.userDir + System.getProperty( "file.separator" ) + "index.sql");
        closeConnection();
      } 
      catch (Exception e)
      {e.printStackTrace();}
    }
    
    public void processFile (String myFile) throws Exception
    {
        BufferedReader reader = new BufferedReader (new FileReader(new File(myFile)));
        boolean finished = false;
        
        StringBuffer command = new StringBuffer();
        while (! finished)
        {
          String line = reader.readLine();
          if (line == null)
          {
             if (command.length() > 0) 
             {
               String befehl = command.toString().replaceAll(";","");
               System.out.println (befehl);
               try{stmt.execute(befehl);}
               catch (Exception e){e.printStackTrace();}
               befehl = null;
               command = null;
             }   
            finished = true;
          }    
          else if (line.trim().length() == 0 || line.startsWith("--"))
          {
             if (command.length() > 0) 
             {
               String befehl = command.toString().replaceAll(";","");
               System.out.println (befehl);
               try{stmt.execute(befehl);}
               catch (Exception e)
               {
                  e.printStackTrace();
               }
               befehl = null;
               command = new StringBuffer();
             }  
          } 
          else 
          {
            line = line.replaceAll ("\\$user\\$", session.defaultUser);
            line = line.replaceAll ("\\$password\\$", session.defaultUserPasswd);
            line = line.replaceAll ("\\$service\\$", session.sServiceName);
            command.append(line);
            command.append (" ");
          }
        }    

    }
    
    public void DropSchema ()
    {
    
    }
        
    public void dropIndex()
    {
        
    }
    
    void closeConnection()
    {
      if (stmt != null)  
      try{stmt.close();}
      catch (Exception e){}
      stmt=null;
      
      if (conn != null)  
      try{conn.close();}
      catch (Exception e){}
      conn=null;
    }
    
    void openConnection()
    {
      try
      {
        conn= session.getMysqlConnection();
        stmt = conn.createStatement();
      }
      catch (Exception e)
      {e.printStackTrace();}
    }
    
    void openAdminConnection()
    {
      try
      {
        conn= session.getAdminMysqlConnection();
        stmt = conn.createStatement();
      }
      catch (Exception e)
      {e.printStackTrace();}
    }
    
    void storeDescriptor() throws Exception
    {      
      String s = System.getProperty( "file.separator" );
      File file = new File (session.userDir + s + "bingo" + s + "data" + s + "accounts.dat");
      String descriptor = session.defaultUser + ";" + session.defaultUserPasswd + ";" + session.sHost + ";" + session.sServiceName;
      BufferedWriter to;
      
      if (file.exists())
      {
        File tmp = new File (session.userDir + s + "bingo" + s + "data" + s + "accounts.tmp");
        file.renameTo (tmp);
        file = new File (session.userDir + s + "bingo" + s + "data" + s + "accounts.dat");
        BufferedReader from = new BufferedReader (new FileReader (tmp));
        to = new BufferedWriter (new FileWriter (file));
 
        String line = from.readLine();
        while (line != null)
        {
          to.write(line);
          to.newLine();
          line = from.readLine();
        }    
        from.close();
        tmp.delete();
      }
      else
      {
         to = new BufferedWriter (new FileWriter (file));
      }
      to.write (descriptor);
      to.flush(); to.close();
    }
    
    public static void main(String[] s)
    {
      new SchemaManagerMysql().createSchema();
      System.exit(0);
    }
}
 