package examples.db;

import jodd.datetime.JDateTime;
import jodd.db.profile.SqlProfileData;
import jodd.db.profile.SqlProfilerHandler;
import jodd.util.Util;

public class SimpleProfilerHandler implements SqlProfilerHandler {

	public void onExecuteQuery(SqlProfileData spd) {
		onExecute(spd);
	}

	public void onExecuteUpdate(SqlProfileData spd) {
		onExecute(spd);
	}

	private synchronized void onExecute(SqlProfileData spd) {
		StackTraceElement[] ste = Util.getStackTrace();
		System.out.println("\n>>> sql profiling ");
		System.out.println(">>> " + ste[3].getClassName() + "." + ste[3].getMethodName() + "():" + ste[3].getLineNumber());
		System.out.println(">>> " + spd.getSqlQuery());
		JDateTime gt = new JDateTime(spd.getQueryTime());
		System.out.println(">>> " + gt + "ms");
		System.out.println(">>> " + spd.getDuration() + "ms\n");
	}
}
