package jodd.bean;

/**
 * Object converter interface
 *
 * @see ConvertersManager
 */
public interface Converter {

	/**
	 * Converts object received as parameter into object of another class.
	 * For example, in a IntegerConverter implementation of this interface,
	 * this method should convert all objects into Integer object. Conversion has
	 * to be done correctly, with investigation of given object.
	 * <p>
	 *
	 * If conversion is not possible, and <code>IllegalParameterException</code>
	 * should be thrown.
	 *
	 * @param obj    object to convert from
	 *
	 * @return resulting object
	 */
	public Object convert(Object obj);

}
