package jodd.bean.converters;

import java.math.BigDecimal;

/**
 * Converts given object to BigDecimal.
 */

public final class BigDecimalConverter implements jodd.bean.Converter {

	public Object convert(Object value) {

		if (value == null) {
			return (BigDecimal) null;
		}
	
		if (value instanceof BigDecimal) {
			return value;
		}
	
		try {
			return (new BigDecimal(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("BigDecimal conversion for " + value +  " failed.");
		}
	}
}
