package jodd.bean.converters;

import java.math.BigInteger;

/**
 * Converts given object to BigInteger.
 */

public final class BigIntegerConverter implements jodd.bean.Converter {

	public Object convert(Object value) {

		if (value == null) {
			return (BigInteger) null;
		}
	
		if (value instanceof BigInteger) {
			return value;
		}
	
		try {
			return (new BigInteger(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("BigInteger conversion for " + value +  " failed.");
		}
	}
}
