package jodd.bean.converters;

/**
 * Converts given object to Boolean. Given object (if not already instance of
 * Boolean) is first converted to String and then analyzed.
 */
public class BooleanConverter implements jodd.bean.Converter {

	public Object convert(Object value) {
		if (value == null) {
			return (Boolean) null;
		}
		if (value instanceof Boolean) {
			return value;
		}
		try {
			String stringValue = value.toString();
			if (stringValue.equalsIgnoreCase("yes") ||
				stringValue.equalsIgnoreCase("y") ||
				stringValue.equalsIgnoreCase("true") ||
				stringValue.equalsIgnoreCase("on") ||
				stringValue.equalsIgnoreCase("1")) {
				return Boolean.TRUE;
			} else if (stringValue.equalsIgnoreCase("no") ||
					   stringValue.equalsIgnoreCase("n") ||
					   stringValue.equalsIgnoreCase("false") ||
					   stringValue.equalsIgnoreCase("off") ||
					   stringValue.equalsIgnoreCase("0")) {
				return Boolean.FALSE;
			} else {
				throw new IllegalArgumentException("Boolean conversion for " + value + " failed.");
			}
		} catch (ClassCastException e) {
			throw new IllegalArgumentException("Boolean cast for " + value + " failed.");
		}
	}
}
