package jodd.bean.converters;

/**
 * Converts given object to Byte. Given object (if not already instance of
 * Byte) is first converted to String and then analyzed.
 */

public class ByteConverter implements jodd.bean.Converter {


	public Object convert(Object value) throws IllegalArgumentException {
		
		if (value == null) {
			return (Byte) null;
		}

		if (value instanceof Byte) {
			return (value);
		} else if (value instanceof Number) {
			return new Byte(((Number)value).byteValue());
		}
		try {
			return (new Byte(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("Byte conversion for " + value +  " failed.");
		}
	}

}
