package jodd.bean.converters;

/**
 * Converts given object to Double.
 */
public final class DoubleConverter implements jodd.bean.Converter {

	public Object convert(Object value) {

		if (value == null) {
			return (Double) null;
		}

		if (value instanceof Double) {
			return value;
		} else if (value instanceof Number) {
			return new Double(((Number)value).doubleValue());
		}

		try {
			return (new Double(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("Double conversion for " + value +  " failed.");
		}
	}
}
