package jodd.bean.converters;

/**
 * Converts given object to Float.
 */
public final class FloatConverter implements jodd.bean.Converter {

	public Object convert(Object value) {

		if (value == null) {
			return (Float) null;
		}

		if (value instanceof Float) {
			return value;
		} else if (value instanceof Number) {
			return new Float(((Number)value).floatValue());
		}

		try {
			return (new Float(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("Float conversion for " + value +  " failed.");
		}
	}
}
