package jodd.bean.converters;

/**
 * Converts given object to an Integer.
 */
public final class IntegerConverter implements jodd.bean.Converter {

	public Object convert(Object value) throws IllegalArgumentException {
		
		if (value == null) {
			return (Integer) null;
		}

		if (value instanceof Integer) {
			return (value);
		} else if (value instanceof Number) {
			return new Integer(((Number)value).intValue());
		}
		try {
			return (new Integer(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("Integer conversion for " + value +  " failed.");
		}
	}
}
