package jodd.bean.converters;

import java.sql.Date;


/**
 * Converts given object to java.sql.Date.
 */
public final class SqlDateConverter implements jodd.bean.Converter {

	public Object convert(Object value) {
	
		if (value == null) {
			return (Date) null;
		}
	
		if (value instanceof Date) {
			return value;
		}
	
		try {
			return (Date.valueOf(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("SqlDate conversion for " + value +  " failed.");
		}
	}
}
