package jodd.bean.converters;

import java.sql.Time;

/**
 * Converts given object to java.sql.Time.
 */
public final class SqlTimeConverter implements jodd.bean.Converter {

	public Object convert(Object value) {

		if (value == null) {
			return (Time) null;
		}
		if (value instanceof Time) {
			return value;
		}

		try {
			return (Time.valueOf(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("SqlTime conversion for " + value +  " failed.");
		}
	}

}
