package jodd.bean.converters;

import java.sql.Timestamp;

/**
 * Converts given object to java.sql.Timestamp.
 */
public final class SqlTimestampConverter implements jodd.bean.Converter {


	public Object convert(Object value) {
		if (value == null) {
			return (Timestamp) null;
		}
	
		if (value instanceof Timestamp) {
			return value;
		}
		try {
			return (Timestamp.valueOf(value.toString()));
		} catch (Exception e) {
			throw new IllegalArgumentException("SqlTimestamp conversion for " + value +  " failed.");
		}
	}

}
