package jodd.bean.converters;

/**
 * Converts given object to String[].
 * If object is an array than it is converted to String[] array.
 * If object is not an array, new String[] array will be created with one
 * element only: String of the given object.
 */
public class StringArrayConverter implements jodd.bean.Converter {

	public Object convert(Object value) {

		if (value == null) {
			return (String) null;
		}

		// handle arrays
		if (value.getClass().isArray() == true) {
			if (value instanceof String[]) {
				return (String[]) value;
			} else {
				Object[] valueArray = (Object[]) value;
				String[] result = new String[valueArray.length];
				for (int i = 0; i < valueArray.length; i++) {
					result[i] = valueArray[i].toString();
				}
				return result;
			}
		}
		// handle all other values
		return new String[] { value.toString() };
	}
}
