package jodd.bean.loaders;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.StringTokenizer;

import jodd.bean.BeanUtil;

/**
 * Populate java bean from ResultSet objects.
 */
public class ResultSetLoader implements jodd.bean.Loader {

	public void load(Object bean, Object rs) {
		if (rs instanceof ResultSet) {
			try {
				ResultSetMetaData rsmd = ((ResultSet)rs).getMetaData();
				int numberOfColumns = rsmd.getColumnCount();
				for (int i = 1; i <= numberOfColumns; i++) {
					StringTokenizer st = new StringTokenizer(rsmd.getColumnName(i), "_");
					StringBuffer columnName = new StringBuffer();
					while (st.hasMoreTokens()) {
						String token = st.nextToken().toLowerCase();
						columnName.append(token.substring(0, 1).toUpperCase()).append(token.substring(1));
					}
					BeanUtil.setProperty(bean, columnName.toString(), ((ResultSet)rs).getObject(i));
				}
			} catch (SQLException sex) {
			} catch (Exception ex) {
			}
		}
		return;
	}
}

