package jodd.bean.modifiers;

import jodd.bean.BeanUtil;

/**
 * Simple bean modifier that trims all String parameters of given java bean object.
 */
public class TrimStrings implements jodd.bean.PropertyCallback {

	public void onProperty(Object obj, String name) {
		if (obj != null) {
			Object value = BeanUtil.getProperty(obj, name);
			if (value != null) {
				if (value instanceof String) {					// trim String parameter
					value = ((String)value).trim();
					BeanUtil.setProperty(obj, name, value);
				} else if (value.getClass().isArray() == true) {
					if (value instanceof String[]) {			// trim String[] parameter
						String[] valueArray = (String[]) value;
						for (int i = 0; i < valueArray.length; i++) {
							valueArray[i] = valueArray[i].trim();
						}
					} else {
						Object[] valueArray = (Object[]) value;	// trim Strings in Object[] parameter
						for (int i = 0; i < valueArray.length; i++) {
							if (valueArray[i] instanceof String) {
								valueArray[i] = ((String)valueArray[i]).trim();
							}
						}
					}
				}
			}
		}
		return;
	}
}
