package jodd.datetime;

/**
 * Interface for various converters from/to JDateTime.
 */
public interface JdtConverter {

	/**
	 * Loads time information from object to JDateTime
	 *
	 * @param jdt
	 * @param o
	 */
	public void load(JDateTime jdt, Object o);

	/**
	 * Creates a new instance of specified class and loads it with the time
	 * information from JDateTime.
	 *
	 * @param jdt
	 *
	 * @return new instance of specified class populated with time information
	 * @see #store
	 */
	public Object get(JDateTime jdt);


	/**
	 * Stores time information to object.
	 *
	 * @param jdt
	 * @param o
	 */
	public void store(JDateTime jdt, Object o);

}
