package jodd.datetime;

/**
 * Implementations holds date strings in various languages.
 */
public interface JdtNames {

	/**
	 * Returns months full names [January - December].
	 *
	 * @return string array of months full names.
	 */
	public String[] getMonths();

	/**
	 * Returns months short names [Jan - Dec].
	 *
	 * @return string array of months short names.
	 */
	public String[] getShortMonths();

	/**
	 * Returns weekdays full names [Monday - Sunday].
	 *
	 * @return string array of weekdays full names.
	 */
	public String[] getDaysOfWeek();

	/**
	 * Returns weekdays short names [Mon - Sun].
	 *
	 * @return string array of weekdays short names.
	 */
	public String[] getShortDaysOfWeek();

}
