package	jodd.datetime.converters;

import java.util.Calendar;
import java.util.GregorianCalendar;

import jodd.datetime.DateTimeStamp;
import jodd.datetime.JDateTime;

public class GregorianCalendarConverter implements jodd.datetime.JdtConverter {

	public void load(JDateTime gt, Object o) {
		if (o instanceof GregorianCalendar) {
			GregorianCalendar c = (GregorianCalendar) o;
			gt.set(c.get(Calendar.YEAR), c.get(Calendar.MONTH) + 1, c.get(Calendar.DAY_OF_MONTH), c.get(Calendar.HOUR_OF_DAY), c.get(Calendar.MINUTE), c.get(Calendar.SECOND) + (double) c.get(Calendar.MILLISECOND) / 1000);
		}
	}

	public Object get(JDateTime gt) {
		GregorianCalendar c = new GregorianCalendar();
		store(gt, c);
		return c;
	}


	public void store(JDateTime gt, Object o) {
		if (o instanceof GregorianCalendar) {
			GregorianCalendar gc = (GregorianCalendar) o;
			DateTimeStamp time = gt.getDateTimeStamp();
			gc.set(time.year, time.month - 1, time.day, time.hour, time.minute, (int)time.second);
			gc.set(GregorianCalendar.MILLISECOND, (int) ((time.second - (int)time.second) * 1000));
		}
	}
}
