package jodd.db.pool;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;


/**
 * Standard usage of the database, without pooling.
 */
public class NoConnectionPool implements ConnectionPool {

	// ---------------------------------------------------------------- properties

	private String driver;
	public void setDriver(String s) {
		driver = s;
	}
	private String url;
	public void setUrl(String s) {
		url = s;
	}
	private String user;
	public void setUser(String s) {
		user = s;
	}
	private String password;
	public void setPassword(String s) {
		password = s;
	}

	// ---------------------------------------------------------------- init/close

	public NoConnectionPool() {
	}

	public void init() throws SQLException {
		try {
			Class.forName(driver);
		} catch (ClassNotFoundException e) {
			throw new SQLException("Database driver not found: " + driver);
		}
	}

	public void close() {
	}

	// ---------------------------------------------------------------- get/free

	public Connection getConnection() throws SQLException {
		return DriverManager.getConnection(url, user, password);
	}

	public void freeConnection(Connection conn) {
		try {
			if (conn != null) {
				conn.close();
			}
		} catch (SQLException e) {
		}
	}

}

