package jodd.db.profile;

/**
 * Holder for profile data. Objects of this class are sent to
 * callback object.
 *
 * @see SqlUtilProfiler
 */
public class SqlProfileData {

	private long queryTime;
	/**
	 * Sets current milliseconds just before query was executed.
	 *
	 * @param v
	 */
	void setQueryTime(long v) {
		queryTime = v;
	}
	/**
	 * Returns milliseconds of the moment just before query was executed.
	 *
	 * @return query time in ms.
	 */
	public long getQueryTime() {
		return queryTime;
	}


	private long duration;
	/**
	 * Sets query duration in ms.
	 *
	 * @param v
	 */
	void setDuration(long v) {
		duration = v;
	}
	/**
	 * Returns query duration in ms.
	 *
	 * @return query duration in ms.
	 */
	public long getDuration() {
		return duration;
	}


	private String sqlquery;
	/**
	 * Sets executed sql query.
	 *
	 * @param v
	 */
	void setSqlQuery(String v) {
		sqlquery = v;
	}

	/**
	 * Returns sql query that was executed.
	 *
	 * @return sql query
	 */
	public String getSqlQuery() {
		return sqlquery;
	}
	
	

}
