package jodd.db.profile;

/**
 * Interface of a sql profiler handler, that recieves information
 * abput sql execution. Usually, profiler handler just logs profile data
 * in the file, or calculate top N queries etc.
 *
 * @see SqlUtilProfiler
 */
public interface SqlProfilerHandler {

	/**
	 * Called after execute query was performed and measured.
	 *
	 * @param spd    measured data
	 */
	public void onExecuteQuery(SqlProfileData spd);

	/**
	 * Called after execute update was performed and measured.
	 *
	 * @param spd    measured data
	 */
	public void onExecuteUpdate(SqlProfileData spd);
}
