package jodd.idgen;

import java.sql.ResultSet;

import jodd.db.SqlUtil;
import jodd.db.pool.ConnectionPool;

/**
 * Uses database sequence for generating new unique keys.
 */
public class SequenceIdGenerator {

	private ConnectionPool pool;
	public void setConnectionPool(ConnectionPool cp) {
		pool = cp;
	}

	private String sequenceSql;
	public void setSequenceName(String s) {
		sequenceSql = "select " + s + ".nextval from dual";
	}


	public SequenceIdGenerator() {
	}

	public SequenceIdGenerator(ConnectionPool cp, String name) {
		setConnectionPool(cp);
		setSequenceName(name);
	}

	public long next() {
		int next = -1;
		ResultSet rs = null;
		SqlUtil dbsql = new SqlUtil(pool);
		try {
			dbsql.setSql(sequenceSql);
			rs = dbsql.executeQuery();
			if (rs.next()) {
				next = rs.getInt(1);
			}
			dbsql.close();
		} catch (Exception e) {
		} finally {
			dbsql.closeAll();
		}
		return next;
	}

	public long nextLong() {
		long next = -1;
		ResultSet rs = null;
		SqlUtil dbsql = new SqlUtil(pool);
		try {
			dbsql.setSql(sequenceSql);
			rs = dbsql.executeQuery();
			if (rs.next()) {
				next = rs.getLong(1);
			}
			dbsql.close();
		} catch (Exception e) {
		} finally {
			dbsql.closeAll();
		}
		return next;
	}

}
