package jodd.log.impl;

import jodd.log.SimpleLogger;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

/**
 * Simple adapter for Log4J logger.
 */
public class Log4jSimpleLogger implements SimpleLogger {

	private static final String callerFQCN = Log4jSimpleLogger.class.getName();

	// ---------------------------------------------------------------- logger

	public static Log4jSimpleLogger getLogger(String loggerName) {
		return new Log4jSimpleLogger(Logger.getLogger(loggerName));
	}

	public static Log4jSimpleLogger getLogger(Class clazz) {
		return new Log4jSimpleLogger(Logger.getLogger(clazz));
	}

	private Logger log = null;

	private Log4jSimpleLogger(Logger l) {
		log = l;
	}


	// ---------------------------------------------------------------- configure

	public static void configure(String configFile) {
		PropertyConfigurator.configure(configFile);
	}

	// ---------------------------------------------------------------- interface

	public void debug(Object message) {
		log.log(callerFQCN, Level.DEBUG, message, null);
	}
	public void debug(Object message, Throwable t) {
		log.log(callerFQCN, Level.DEBUG, message, t);
	}

	public void info(Object message) {
		log.log(callerFQCN, Level.INFO, message, null);
	}
	public void info(Object message, Throwable t) {
		log.log(callerFQCN, Level.INFO, message, t);
	}

	public void warn(Object message) {
		log.log(callerFQCN, Level.WARN, message, null);
	}
	public void warn(Object message, Throwable t) {
		log.log(callerFQCN, Level.WARN, message, t);
	}

	public void error(Object message) {
		log.log(callerFQCN, Level.ERROR, message, null);
	}
	public void error(Object message, Throwable t) {
		log.log(callerFQCN, Level.ERROR, message, t);
	}

	public void fatal(Object message) {
		log.log(callerFQCN, Level.FATAL, message, null);
	}
	public void fatal(Object message, Throwable t) {
		log.log(callerFQCN, Level.FATAL, message, t);
	}

}
