package jodd.servlet.tags.imports;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * Inserts parameters defined in import tag. Usually used in templates itself
 * to define where to put parameters defined in import tag.
 *
 * @see Import
 */
public class ImportInsert extends TagSupport {

	private String name = "";
	/**
	 * Sets parameter name (required).
	 *
	 * @param v      parameter name
	 */
	public void setName(String v) {
		name = v;
	}
	/**
	 * Returns parameter name.
	 *
	 * @return parameter name
	 */
	protected String getName() {
		return name;
	}

	/**
	 * Just renders parameters value. It is readed from the request.
	 *
	 * @return value of the parameter
	 */
	public int doStartTag() {
		String value = (String) pageContext.getRequest().getAttribute(name);
		JspWriter out = pageContext.getOut();
		try {
			out.write(value);
		} catch (IOException ioex) {
		}
		return SKIP_BODY;
	}
}

