package jodd.util;

/**
 * Thread utilities.
 */

public final class ThreadUtil {

	/**
	 * Puts a thread to sleep, without throwing an InterruptedException.
	 *
	 * @param ms     the length of time to sleep in milliseconds
	 */
	public static void sleep(long ms) {
		try {
			Thread.sleep(ms);
		} catch (InterruptedException iex) {
		}
	}


	/**
	 * Puts a thread to sleep forever.
	 *
	 * @see #sleep(long ms)
	 */
	public static void sleep() {
		sleep(Long.MAX_VALUE);
	}
}
