package stored.mi;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Vector;

public class MiTreeNode {
  public HashSet terms;
  // Not synchronized
  public HashMap documents;
  // Not synchronized
  public ArrayList nachfolger;
  // Not synchronized
  public MiTreeNode vorgaenger;
  public String name;
  public int class_ID;
  public int numDocuments;
  public HashMap numPositive;
  public HashMap numNegative;
  public int numGesamt;


  public void addTerm( String t ) {
    synchronized ( terms ) {
      terms.add( t );
    }
  }


  public void removeTerm( String t ) {
    synchronized ( terms ) {
      terms.remove( t );
    }
    synchronized ( numPositive ) {
      numPositive.remove( t );
    }
    synchronized ( numNegative ) {
      numNegative.remove( t );
    }
  }


  public void addNachfolger( MiTreeNode n ) {
    if ( n != null ) {
      synchronized ( nachfolger ) {
        nachfolger.add( n );
      }
    }
  }


  public void removeNachfolger( MiTreeNode n ) {
    if ( n != null ) {
      synchronized ( nachfolger ) {
        nachfolger.remove( n );
      }
    }
  }


  public MiTreeNode( String n, int id ) {
    terms = new HashSet();
    documents = new HashMap();
    nachfolger = new ArrayList();
    name = n;
    class_ID = id;
    numDocuments = 0;
    numPositive = new HashMap();
    numNegative = new HashMap();
    numGesamt = -1;
  }


  public MiTreeNode() {
    terms = new HashSet();
    documents = new HashMap();
    nachfolger = new ArrayList();
    vorgaenger = null;
    numDocuments = 0;
    numPositive = new HashMap();
    numNegative = new HashMap();
    numGesamt = -1;
  }


  public void setName( String n ) {
    name = n;
    class_ID = getID( name );
  }


  public String getName() {
    return name;
  }


  public int getID( String who ) {
    return who.hashCode();
  }


  public HashSet getTerms() {
    return terms;
  }


  public ArrayList getNachfolger() {
    return nachfolger;
  }


  public void setVorgaenger( MiTreeNode vor ) {
    vorgaenger = vor;
  }


  public void removeVorgaenger() {
    vorgaenger = null;
  }


  public MiTreeNode getVorgaenger() {
    return vorgaenger;
  }


  public int getID() {
    return class_ID;
  }


  public void addDocument( long i ) {
    synchronized ( documents ) {
      documents.put( new Long( i ), new HashSet() );
    }
    numDocuments++;
  }


  public void addDocument( long i, HashSet h ) {
    synchronized ( documents ) {
      documents.put( new Long( i ), h );
    }
    numDocuments++;
  }


  public Vector getTasks() {
    Iterator it;

    Vector antwort = new Vector();

    it = terms.iterator();
    while ( it.hasNext() ) {
      antwort.add( new MiTask( this, class_ID, (String) it.next() ) );
    }

    it = nachfolger.iterator();
    while ( it.hasNext() ) {
      Enumeration enum = ( ( (MiTreeNode) it.next() ).getTasks() ).elements();

      while ( ( enum ).hasMoreElements() ) {
        antwort.add( enum.nextElement() );
      }
    }
    return antwort;
  }
}
