package temp;

import java.io.*;
import java.util.*;

public class StopwordCleaner
{
   
   public static void main(String[] args)
   {
      try
      {
         process(args);
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
   }
   
   
   public static void process(String[] args) throws Exception
   {
      int wordCount = 0;
      
      System.out.println();
      System.out.println("Cleanup program for Snowball stopword files for BINGO!");
      System.out.println("- removes english comments on particular language-specific stopwords");
      System.out.println("(c) Sergej Sizov, 2004");
     
      if (args.length < 1)
      {
         System.out.println();
         System.out.println("Usage: 'StopwordCleaner <language>', e.g 'StopwordCleaner french'");
         System.exit(0);
      }
      
      StringBuffer dir = new StringBuffer(200);
      dir.append(System.getProperty("user.dir"));
      dir.append(System.getProperty("file.separator"));
      
      dir.append("bingo");
      dir.append(System.getProperty("file.separator"));
      dir.append("data");
      dir.append(System.getProperty("file.separator"));
      dir.append("stopwords");
      dir.append(System.getProperty("file.separator"));
      dir.append(args[0]);
      dir.append(System.getProperty("file.separator"));
      
      File newFile = new File(dir.toString() + "stopwords.txt");
      File oldFile = new File(dir.toString() + "stopwords.bak");
      
      dir = null;
      
      // System.out.println ("Process file: " + newFile.toString());
      
      if (!newFile.exists())
      {
         System.out.println("Source file not exists: ");
         System.out.println(newFile.toString());
         System.exit(0);
      }
      
      newFile.renameTo(oldFile);
      BufferedReader from = new BufferedReader(new FileReader(oldFile));
      BufferedWriter to = new BufferedWriter(new FileWriter(newFile));
      
      for (String line = from.readLine(); line != null; line = from.readLine())
      {
         if (line == null)
            continue;
         int pos = line.indexOf('|');
         if (pos >= 0)
            line = line.substring(0, pos);
         
         line = line.trim();
         if (line.length() <= 0)
            continue;
         
         wordCount ++;
         to.write(line);
         to.newLine();
      }
      to.flush(); to.close(); to = null;
      from.close(); from = null;
      
      System.out.println("Filtered: " + wordCount + " stopwords");
      System.out.println("Output written to:");
      System.out.println(newFile.toString());
      System.out.println("Backup:");
      System.out.println(oldFile.toString());
      
      newFile = null;
      oldFile = null;
   }
   
}
