/*
 * ParamsDeserializer.java
 *
 * Created on 2. November 2002, 15:42
 */
package webservice;

import org.apache.axis.encoding.DeserializationContext;
import org.apache.axis.encoding.Deserializer;
import org.apache.axis.encoding.DeserializerImpl;
import org.apache.axis.encoding.FieldTarget;
import org.apache.axis.Constants;
import org.apache.axis.message.SOAPHandler;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import javax.xml.namespace.QName;
import java.util.Hashtable;

/**
 * @author     T
 * @created    19. August 2003
 */
public class ParamsDeserializer extends DeserializerImpl {

  private Hashtable typesByMemberName = new Hashtable();
  private String[] members;


  public ParamsDeserializer() {
    int iMembers = 21;

    members = new String[21];
    for ( int i = 0; i < iMembers; i++ ) {
      members[i] = "PARAM" + String.valueOf( i );
    }
    typesByMemberName.put( members[0], Constants.XSD_STRING );
    typesByMemberName.put( members[1], Constants.XSD_INTEGER );
    typesByMemberName.put( members[2], Constants.XSD_INTEGER );
    typesByMemberName.put( members[3], Constants.XSD_INTEGER );
    typesByMemberName.put( members[4], Constants.XSD_INTEGER );
    typesByMemberName.put( members[5], Constants.XSD_INTEGER );
    typesByMemberName.put( members[6], Constants.XSD_BOOLEAN );
    typesByMemberName.put( members[7], Constants.XSD_INTEGER );
    typesByMemberName.put( members[8], Constants.XSD_INTEGER );
    typesByMemberName.put( members[9], Constants.XSD_INTEGER );
    typesByMemberName.put( members[10], Constants.XSD_INTEGER );
    typesByMemberName.put( members[11], Constants.XSD_INTEGER );
    typesByMemberName.put( members[12], Constants.XSD_BOOLEAN );
    typesByMemberName.put( members[13], Constants.XSD_INTEGER );
    typesByMemberName.put( members[14], Constants.XSD_BOOLEAN );
    typesByMemberName.put( members[15], Constants.XSD_DOUBLE );
    typesByMemberName.put( members[16], Constants.XSD_INTEGER );
    typesByMemberName.put( members[17], Constants.XSD_INTEGER );
    typesByMemberName.put( members[18], Constants.XSD_BOOLEAN );
    typesByMemberName.put( members[19], Constants.XSD_BOOLEAN );
    typesByMemberName.put( members[20], Constants.XSD_INTEGER );

  }


  public SOAPHandler onStartChild( String namespace,
      String localName,
      String prefix,
      Attributes attributes,
      DeserializationContext context )
       throws SAXException {
    QName typeQName = (QName) typesByMemberName.get( localName );

    if ( typeQName == null ) {
      throw new SAXException( "Invalid element in Data struct - " + localName );
    }

    // These can come in either order.
    Deserializer dSer = context.getDeserializerForType( typeQName );

    try {
      dSer.registerValueTarget( new FieldTarget( value, localName ) );
    }
    catch ( NoSuchFieldException e ) {
      throw new SAXException( e );
    }

    if ( dSer == null ) {
      throw new SAXException( "No deserializer for a " + typeQName + "???" );
    }

    return (SOAPHandler) dSer;
  }
}

