/*
 * ParamsSerializer.java
 *
 * Created on 2. November 2002, 15:37
 */
package webservice;

import org.apache.axis.encoding.SerializationContext;
import org.apache.axis.encoding.Serializer;
import org.apache.axis.message.SOAPHandler;
import org.apache.axis.Constants;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.apache.axis.Constants;
import org.apache.axis.wsdl.fromJava.Types;

import javax.xml.namespace.QName;
import java.io.IOException;
import java.util.Hashtable;

import bingo.adapter.BingoParameters;

/**
 * @author     T
 * @created    19. August 2003
 */
public class ParamsSerializer implements Serializer {

  private String[] members;


  public ParamsSerializer() {
    int iMembers = 21;

    members = new String[21];
    for ( int i = 0; i < iMembers; i++ ) {
      members[i] = "PARAM" + String.valueOf( i );
    }
  }


  public void serialize( QName name, Attributes attributes,
      Object value, SerializationContext context )
       throws IOException {
    if ( !( value instanceof BingoParameters ) ) {
      throw new IOException( "Can't serialize a " + value.getClass().getName() + " with a ParamsSerializer." );
    }
    BingoParameters p = (BingoParameters) value;

    context.startElement( name, attributes );
    context.serialize( new QName( "", members[0] ), null, p.homeDirectory );
    context.serialize( new QName( "", members[1] ), null, new Integer( p.numDF ) );
    context.serialize( new QName( "", members[2] ), null, new Integer( p.numMI ) );
    context.serialize( new QName( "", members[3] ), null, new Integer( p.numHITS ) );
    context.serialize( new QName( "", members[4] ), null, new Integer( p.maxCrawlerThreads ) );
    context.serialize( new QName( "", members[5] ), null, new Integer( p.downloadTimeout ) );
    context.serialize( new QName( "", members[6] ), null, new Boolean( p.offlineCrawling ) );
    context.serialize( new QName( "", members[7] ), null, new Integer( p.batchSize ) );
    context.serialize( new QName( "", members[8] ), null, new Integer( p.chunkSize ) );
    context.serialize( new QName( "", members[9] ), null, new Integer( p.numGoogleLink ) );
    context.serialize( new QName( "", members[10] ), null, new Integer( p.numGoogleRelated ) );
    context.serialize( new QName( "", members[11] ), null, new Integer( p.useSVMClassifier ) );
    context.serialize( new QName( "", members[12] ), null, new Boolean( p.saveStopwordTerms ) );
    context.serialize( new QName( "", members[13] ), null, new Integer( p.maxCrawlingDepth ) );
    context.serialize( new QName( "", members[14] ), null, new Boolean( p.storeStreams ) );
    context.serialize( new QName( "", members[15] ), null, new Double( p.dThreshold ) );
    context.serialize( new QName( "", members[16] ), null, new Integer( p.modellingType ) );
    context.serialize( new QName( "", members[17] ), null, new Integer( p.maxQueueSize ) );
    context.serialize( new QName( "", members[18] ), null, new Boolean( p.hardFocus ) );
    context.serialize( new QName( "", members[19] ), null, new Boolean( p.softFocus ) );
    context.serialize( new QName( "", members[20] ), null, new Integer( p.maxTunnelDistance ) );
    context.endElement();
    System.out.println( "SERIALIZED" );
  }


  public String getMechanismType() {
    return Constants.AXIS_SAX;
  }


  public org.w3c.dom.Element writeSchema( Class cl, Types types ) throws Exception {
    return null;
  }
}
