import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import jodd.servlet.*;

public class FooAction extends ActionServlet {

	/**
	 * Main entry point for handling fooaction requests. This ActionServlet
	 * is used as enhancement of the HttpServlet.
	 *
	 * @param request
	 * @param response
	 *
	 * @exception IOException
	 * @exception ServletException
	 */
	public void doRequest(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		System.out.println("---------------------");
		System.out.println("FooAction.doRequest()");

		// invoke action specified by request parameter 'action'
		String s = invokeAction(request, response);
		System.out.println("invoking result: " + s);
		if (s != null) {
			return;						// invoking was sucessfull
		}

		// no action (method) has been invoked, try to use
		// forward or redirect params anyway, if they exist
		if (forwardParam(request, response)) return;
		if (redirectParam(request, response)) return;
		
		// none of the three parameters (action, forward, redirect) has been specified
		// do the default behaviour
		System.out.println("nothing to do, just go back...");
		redirect(request, response, "index.html");
	}

	/**
	 * The first http request handler (i.e. action). The important thing to
	 * remember is that this method may return anything, any kind of object, it
	 * will be converted to String representation. For the example, if boolean
	 * value of true is returned (as here), doRequest() will got the String with
	 * value "true". This may be useful for noticing if some action method
	 * actually has been invoked, so doRequest can return back.
	 *
	 * @param request
	 * @param response
	 *
	 * @return
	 * @exception IOException
	 * @exception ServletException
	 */
	public boolean one(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		System.out.println(">ACTION #1");
		return true;
	}

	public boolean two(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		System.out.println(">ACTION #2, redirect");
		redirectParam(request, response);
		return true;
	}

	public boolean three(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		System.out.println(">ACTION #3, forward");
		forwardParam(request, response);
		return true;
	}


}

