// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 24.03.2004 15:52:10
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   AllPairsAlgorithm.java

package gd;

import graph.*;

// Referenced classes of package gd:
//            GDAlgorithm

public class AllPairsAlgorithm extends GDAlgorithm
{

    public AllPairsAlgorithm(double d, double d1)
    {
        super.springConstant = d;
        super.nodeCharge = d1;
    }

    public synchronized double energy(Graph graph)
    {
        double d = 0.0D;
        for(int i = 0; i < graph.sizeNodes; i++)
            d += energy(graph, graph.nodes[i], 0.0D, 0.0D) / 2D;

        return d;
    }

    public synchronized double improveGraph(Graph graph)
    {
        if(graph.sizeNodes == 0)
            return 0.0D;
        double d = graph.barycenter.x;
        double d1 = graph.barycenter.y;
        boolean flag = false;
        for(int i = 0; i < graph.sizeNodes; i++)
            flag |= graph.nodes[i].fixed;

        double d2 = 0.0D;
        for(int j = 0; j < graph.sizeNodes; j++)
            d2 += improveNode(graph, graph.nodes[j]);

        if(!flag)
            graph.center(d, d1);
        return d2;
    }

    private synchronized Coords repulsionForce(Node node, Node node1, double d, double d1)
    {
        double d2 = (node.x + d) - node1.x;
        double d3 = (node.y + d1) - node1.y;
        double d4 = My.square((double)(node.width + node1.width + 1) * d2) + My.square((double)(node.height + node1.height + 1) * d3);
        if(d4 == 0.0D)
        {
            return new Coords(Math.random() - 0.5D, Math.random() - 0.5D);
        } else
        {
            double d5 = (My.square(super.nodeCharge) * (double)node.degree * (double)node1.degree) / Math.pow(d4, 1.5D);
            return new Coords(d5 * d2, d5 * d3);
        }
    }

    private synchronized double repulsionEnergy(Node node, Node node1, double d, double d1)
    {
        double d2 = (node.x + d) - node1.x;
        double d3 = (node.y + d1) - node1.y;
        double d4 = My.square((double)(node.width + node1.width + 1) * d2) + My.square((double)(node.height + node1.height + 1) * d3);
        if(d4 == 0.0D)
            return 1.7976931348623156E+306D;
        else
            return (My.square(super.nodeCharge) * (double)node.degree * (double)node1.degree) / Math.sqrt(d4);
    }

    private synchronized Coords springForce(Node node, Edge edge, double d, double d1)
    {
        double d2 = edge.to.x - edge.from.x;
        double d3 = edge.to.y - edge.from.y;
        if(node == edge.to)
        {
            d2 += d;
            d3 += d1;
        } else
        {
            d2 -= d;
            d3 -= d1;
        }
        double d4 = Math.sqrt(My.square(d2) + My.square(d3));
        double d5 = d4 - edge.restLength;
        double d6 = (2D * super.springConstant * d5) / d4;
        if(node == edge.to)
            d6 = -d6;
        Coords coords = new Coords(d6 * d2, d6 * d3);
        if(edge.directed && d3 > edge.restLength)
            coords.y -= (2D * super.springConstant * (d3 - edge.restLength)) / 2D;
        return coords;
    }

    private synchronized double springEnergy(Edge edge, Node node, double d, double d1)
    {
        double d2 = edge.to.x - edge.from.x;
        double d3 = edge.to.y - edge.from.y;
        if(node == edge.to)
        {
            d2 += d;
            d3 += d1;
        } else
        {
            d2 -= d;
            d3 -= d1;
        }
        double d4 = Math.sqrt(My.square(d2) + My.square(d3));
        double d5 = super.springConstant * My.square(d4 - edge.restLength);
        if(edge.directed && d3 > edge.restLength)
            d5 -= (super.springConstant * My.square(d3 - edge.restLength)) / 2D;
        return d5;
    }

    private synchronized Coords force(Graph graph, Node node, double d, double d1)
    {
        Coords coords = new Coords(0.0D, 0.0D);
        for(int i = 0; i < graph.sizeNodes; i++)
            if(graph.nodes[i] != node)
                coords.add(repulsionForce(node, graph.nodes[i], d, d1));

        for(int j = 0; j < node.degree; j++)
            coords.add(springForce(node, node.incidentEdges[j], d, d1));

        return coords;
    }

    private synchronized double energy(Graph graph, Node node, double d, double d1)
    {
        double d2 = 0.0D;
        for(int i = 0; i < graph.sizeNodes; i++)
            if(graph.nodes[i] != node)
                d2 += repulsionEnergy(node, graph.nodes[i], d, d1);

        for(int j = 0; j < node.degree; j++)
            d2 += springEnergy(node.incidentEdges[j], node, d, d1);

        return d2;
    }

    private synchronized double improveNode(Graph graph, Node node)
    {
        if(node.degree == 0 || node.fixed || !node.placed)
            return 0.0D;
        Coords coords = force(graph, node, 0.0D, 0.0D);
        double d = Math.sqrt(My.square(coords.x) + My.square(coords.y));
        if(d == 0.0D)
        {
            return 0.0D;
        } else
        {
            coords.x /= d;
            coords.y /= d;
            double d1 = energy(graph, node, 0.0D, 0.0D);
            double d2 = quadApprox(graph, node, d1, coords);
            double d3 = coords.x;
            coords.x = coords.y;
            coords.y = -d3;
            d2 += quadApprox(graph, node, d1 + d2, coords);
            coords.x = Math.random();
            coords.y = Math.random();
            d2 += quadApprox(graph, node, d1 + d2, coords);
            graph.placeNode(node, node.x, node.y);
            return d2;
        }
    }

    private synchronized double quadApprox(Graph graph, Node node, double d, Coords coords)
    {
        double d1 = energy(graph, node, coords.x, coords.y);
        double d2 = energy(graph, node, -coords.x, -coords.y);
        double d3 = (d1 + d2) - 2D * d;
        double d4 = (d1 - d2) / 2D;
        double d5 = -d4 / (2D * d3);
        double d6 = energy(graph, node, d5 * coords.x, d5 * coords.y);
        if(d6 < d)
        {
            graph.placeNode(node, node.x + d5 * coords.x, node.y + d5 * coords.y);
            return d - d6;
        } else
        {
            return 0.0D;
        }
    }
}