// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 08.03.2004 15:03:15
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Barycenter.java

package graph;


// Referenced classes of package graph:
//            Edge, Node

public class Barycenter
{

    private void doubleNodeArray()
    {
        Node anode[] = new Node[allocatedNodes * 2];
        for(int i = 0; i < allocatedNodes; i++)
            anode[i] = nodes[i];

        nodes = anode;
        allocatedNodes = allocatedNodes * 2;
    }

    private void doubleEdgeArray()
    {
        Edge aedge[] = new Edge[allocatedEdges * 2];
        for(int i = 0; i < allocatedEdges; i++)
            aedge[i] = edges[i];

        edges = aedge;
        allocatedEdges = allocatedEdges * 2;
    }

    public Barycenter()
    {
        nodes = new Node[1];
        edges = new Edge[1];
        allocatedNodes = 1;
        allocatedEdges = 1;
    }

    public Barycenter(Barycenter barycenter)
    {
        nodes = new Node[1];
        edges = new Edge[1];
        allocatedNodes = 1;
        allocatedEdges = 1;
        parent = barycenter;
    }

    public synchronized void addNode(Node node)
    {
        if(sizeNodes == allocatedNodes)
            doubleNodeArray();
        nodes[sizeNodes++] = node;
        x = (x * (double)(sizeNodes - 1) + node.x) / (double)sizeNodes;
        y = (y * (double)(sizeNodes - 1) + node.y) / (double)sizeNodes;
        width = (width * (double)(sizeNodes - 1) + (double)node.width) / (double)sizeNodes;
        height = (height * (double)(sizeNodes - 1) + (double)node.height) / (double)sizeNodes;
        degree = (degree * (double)(sizeNodes - 1) + (double)node.degree) / (double)sizeNodes;
        node.barycenter = this;
    }

    public synchronized void addEdge(Edge edge)
    {
        if(sizeEdges == allocatedEdges)
            doubleEdgeArray();
        edges[sizeEdges++] = edge;
    }

    public synchronized void moveNode(Node node, double d, double d1)
    {
        x += (d - node.x) / (double)sizeNodes;
        y += (d1 - node.y) / (double)sizeNodes;
        if(parent != null)
            parent.moveNode(node, d, d1);
    }

    public synchronized void removeNode(Node node)
    {
        if(sizeNodes == 1)
        {
            x = 0.0D;
            y = 0.0D;
        } else
        {
            x = (x * (double)sizeNodes - node.x) / (double)(sizeNodes - 1);
            y = (y * (double)sizeNodes - node.y) / (double)(sizeNodes - 1);
            width = (width * (double)sizeNodes - (double)node.width) / (double)(sizeNodes - 1);
            height = (height * (double)sizeNodes - (double)node.height) / (double)(sizeNodes - 1);
            degree = (degree * (double)sizeNodes - (double)node.degree) / (double)(sizeNodes - 1);
        }
        for(int i = 0; i < sizeNodes; i++)
        {
            if(nodes[i] != node)
                continue;
            nodes[i] = nodes[--sizeNodes];
            break;
        }

        for(int j = 0; j < sizeEdges; j++)
        {
            Edge edge = edges[j];
            if(edge.from == node || edge.to == node)
                edges[j] = edges[--sizeEdges];
        }

        if(parent != null)
            parent.removeNode(node);
    }

    public synchronized void translate(double d, double d1)
    {
        for(int i = 0; i < sizeNodes; i++)
        {
            Node node = nodes[i];
            node.x += d;
            node.y += d1;
        }

        for(Barycenter barycenter = this; barycenter != null; barycenter = barycenter.parent)
        {
            barycenter.x += (d * (double)sizeNodes) / (double)barycenter.sizeNodes;
            barycenter.y += (d1 * (double)sizeNodes) / (double)barycenter.sizeNodes;
        }

        translateDescendants(this, d, d1);
    }

    private synchronized void translateDescendants(Barycenter barycenter, double d, double d1)
    {
        if(barycenter.NW != null)
        {
            barycenter.NW.x += d;
            barycenter.NW.y += d1;
            translateDescendants(barycenter.NW, d, d1);
        }
        if(barycenter.NE != null)
        {
            barycenter.NE.x += d;
            barycenter.NE.y += d1;
            translateDescendants(barycenter.NE, d, d1);
        }
        if(barycenter.SW != null)
        {
            barycenter.SW.x += d;
            barycenter.SW.y += d1;
            translateDescendants(barycenter.SW, d, d1);
        }
        if(barycenter.SE != null)
        {
            barycenter.SE.x += d;
            barycenter.SE.y += d1;
            translateDescendants(barycenter.SE, d, d1);
        }
    }

    public double x;
    public double y;
    public double width;
    public double height;
    public double degree;
    public Barycenter NW;
    public Barycenter NE;
    public Barycenter SW;
    public Barycenter SE;
    public Barycenter parent;
    public Node nodes[];
    public int sizeNodes;
    public Edge edges[];
    public int sizeEdges;
    private int allocatedNodes;
    private int allocatedEdges;
}