// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 08.03.2004 15:16:44
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Graph.java

package graph;


// Referenced classes of package graph:
//            Barycenter, Edge, Node

public final class Graph
{

    public Graph()
    {
        barycenter = new Barycenter();
        nodes = new Node[allocatedNodes = DEFAULT_NODE_ALLOC];
        edges = new Edge[allocatedEdges = DEFAULT_EDGE_ALLOC];
    }

    public boolean member(Node node)
    {
        for(int i = 0; i < sizeNodes; i++)
            if(nodes[i] == node)
                return true;

        return false;
    }

    public boolean member(Edge edge)
    {
        if(edge == null || edge.from == null || edge.to == null)
            return false;
        for(int i = 0; i < edge.from.degree; i++)
            if(edge.from.incidentEdges[i] == edge)
                return true;

        return false;
    }

    public Node findNode(String s)
    {
        for(int i = 0; i < sizeNodes; i++)
            if(nodes[i].name.equals(s))
                return nodes[i];

        return null;
    }

    public Edge findEdge(Node node, Node node1)
    {
        if(node == null || node1 == null)
            return null;
        for(int i = 0; i < node.degree; i++)
            if(node.neighbors[i] == node1)
                return node.incidentEdges[i];

        return null;
    }

    public Edge findEdge(String s, String s1)
    {
        return findEdge(findNode(s), findNode(s1));
    }

    public Node addNode(Node node)
    {
        if(member(node))
            return node;
        if(sizeNodes == allocatedNodes)
            doubleNodeArray();
        barycenter.addNode(node);
        return nodes[sizeNodes++] = node;
    }

    public Node addNode()
    {
        return addNode(new Node());
    }

    public Node addNode(String s)
    {
        Node node = findNode(s);
        if(node != null)
            return node;
        else
            return addNode(new Node(s, barycenter));
    }

    public synchronized void placeNode(Node node, double d, double d1)
    {
        if(!node.placed)
        {
            node.placed = true;
            node.x = d;
            node.y = d1;
            barycenter.addNode(node);
            return;
        } else
        {
            node.barycenter.moveNode(node, d, d1);
            node.x = d;
            node.y = d1;
            return;
        }
    }

    public void placeNode(String s, double d, double d1)
    {
        Node node = findNode(s);
        if(node != null)
            placeNode(node, d, d1);
    }

    public void unplaceNode(Node node)
    {
        if(node.placed)
            node.barycenter.removeNode(node);
        node.placed = false;
    }

    public void unplaceNode(String s)
    {
        Node node = findNode(s);
        if(node != null)
            unplaceNode(node);
    }

    public void removeNode(Node node)
    {
        for(int i = 0; i < node.degree; i++)
            node.neighbors[i].removeNeighbor(node);

        for(int j = 0; j < node.degree; j++)
        {
            for(int k = 0; k < sizeEdges; k++)
            {
                if(edges[k] != node.incidentEdges[j])
                    continue;
                edges[k] = edges[--sizeEdges];
                break;
            }

        }

        for(int l = 0; l < sizeNodes; l++)
        {
            if(nodes[l] != node)
                continue;
            nodes[l] = nodes[--sizeNodes];
            break;
        }

        unplaceNode(node);
    }

    public void removeNode(String s)
    {
        Node node = findNode(s);
        if(node != null)
            removeNode(node);
    }

    public Edge addEdge(Edge edge)
    {
        if(member(edge))
            return edge;
        Node node = addNode(edge.from);
        Node node1 = addNode(edge.to);
        node.addNeighbor(edge);
        node1.addNeighbor(edge);
        if(sizeEdges == allocatedEdges)
            doubleEdgeArray();
        return edges[sizeEdges++] = edge;
    }

    public Edge addEdge(Node node, Node node1, double d, String s)
    {
        return addEdge(new Edge(node, node1, d, s));
    }

    public Edge addEdge(Node node, Node node1, double d)
    {
        return addEdge(new Edge(node, node1, d, ""));
    }

    public Edge addEdge(Node node, Node node1, String s)
    {
        return addEdge(new Edge(node, node1, 0.0D, s));
    }

    public Edge addEdge(Node node, Node node1)
    {
        return addEdge(new Edge(node, node1, 0.0D, ""));
    }

    public Edge addEdge(String s, String s1, double d, String s2)
    {
        return addEdge(addNode(s), addNode(s1), d, s2);
    }

    public Edge addEdge(String s, String s1, double d)
    {
        return addEdge(s, s1, d, "");
    }

    public Edge addEdge(String s, String s1, String s2)
    {
        return addEdge(s, s1, 0.0D, s2);
    }

    public Edge addEdge(String s, String s1)
    {
        return addEdge(s, s1, 0.0D, "");
    }

    public void removeEdge(Edge edge)
    {
        edge.from.removeNeighbor(edge);
        edge.to.removeNeighbor(edge);
        for(int i = 0; i < sizeEdges; i++)
            if(edges[i] == edge)
            {
                edges[i] = edges[--sizeEdges];
                return;
            }

    }

    public synchronized boolean refine()
    {
        return refine(barycenter);
    }

    private synchronized boolean refine(Barycenter barycenter1)
    {
        if(barycenter1.sizeNodes <= 4)
            return false;
        if(barycenter1.NW != null)
        {
            boolean flag = refine(barycenter1.NW);
            boolean flag1 = refine(barycenter1.NE);
            boolean flag2 = refine(barycenter1.SW);
            boolean flag3 = refine(barycenter1.SE);
            return flag || flag1 || flag2 || flag3;
        }
        barycenter1.NW = new Barycenter(barycenter1);
        barycenter1.NE = new Barycenter(barycenter1);
        barycenter1.SW = new Barycenter(barycenter1);
        barycenter1.SE = new Barycenter(barycenter1);
        for(int i = 0; i < barycenter1.sizeNodes; i++)
        {
            Node node = barycenter1.nodes[i];
            if(node.barycenter == barycenter1)
            {
                int k = 0;
                int l = 0;
                int i1 = 0;
                int j1 = 0;
                int k1 = 0;
                for(int l1 = 0; l1 < node.degree; l1++)
                {
                    Node node3 = node.neighbors[l1];
                    if(node3.barycenter != barycenter1)
                        if(node3.barycenter == barycenter1.NW)
                            k1 = Math.max(k1, ++k);
                        else
                        if(node3.barycenter == barycenter1.NE)
                            k1 = Math.max(k1, ++l);
                        else
                        if(node3.barycenter == barycenter1.SW)
                            k1 = Math.max(k1, ++i1);
                        else
                        if(node3.barycenter == barycenter1.SE)
                            k1 = Math.max(k1, ++j1);
                }

                if(k1 > 0)
                {
                    if(k == k1)
                        barycenter1.NW.addNode(node);
                    else
                    if(l == k1)
                        barycenter1.NE.addNode(node);
                    else
                    if(i1 == k1)
                        barycenter1.SW.addNode(node);
                    else
                        barycenter1.SE.addNode(node);
                } else
                {
                    if(node.x < barycenter1.x)
                    {
                        if(node.y < barycenter1.y)
                            barycenter1.NW.addNode(node);
                        else
                            barycenter1.SW.addNode(node);
                    } else
                    if(node.y < barycenter1.y)
                        barycenter1.NE.addNode(node);
                    else
                        barycenter1.SE.addNode(node);
                    for(int i2 = 0; i2 < node.degree; i2++)
                    {
                        Node node4 = node.neighbors[i2];
                        if(node4.barycenter == barycenter1)
                            node.barycenter.addNode(node4);
                    }

                }
            }
        }

        for(int j = 0; j < barycenter1.sizeEdges; j++)
        {
            Edge edge = barycenter1.edges[j];
            Node node1 = edge.from;
            Node node2 = edge.to;
            if(node1.barycenter != node2.barycenter)
            {
                node1.barycenter.addEdge(edge);
                node2.barycenter.addEdge(edge);
            }
        }

        return true;
    }

    public void center(double d, double d1)
    {
        barycenter.translate(d - barycenter.x, d1 - barycenter.y);
    }

    public synchronized void reset()
    {
        barycenter = new Barycenter();
        for(int i = 0; i < sizeNodes; i++)
            barycenter.addNode(nodes[i]);

    }

    private void doubleNodeArray()
    {
        Node anode[] = new Node[allocatedNodes * 2];
        for(int i = 0; i < allocatedNodes; i++)
            anode[i] = nodes[i];

        nodes = anode;
        allocatedNodes = allocatedNodes * 2;
    }

    private void doubleEdgeArray()
    {
        Edge aedge[] = new Edge[allocatedEdges * 2];
        for(int i = 0; i < allocatedEdges; i++)
            aedge[i] = edges[i];

        edges = aedge;
        allocatedEdges = allocatedEdges * 2;
    }

    public int sizeNodes;
    public int sizeEdges;
    public Node nodes[];
    public Edge edges[];
    public Barycenter barycenter;
    private int allocatedNodes;
    private int allocatedEdges;
    private static int DEFAULT_NODE_ALLOC = 100;
    private static int DEFAULT_EDGE_ALLOC = 100;

}