// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 08.03.2004 15:03:18
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Node.java

package graph;


// Referenced classes of package graph:
//            Edge, My, Barycenter

public class Node
{

    private void doubleArrays()
    {
        Edge aedge[] = new Edge[allocation * 2];
        for(int i = 0; i < allocation; i++)
            aedge[i] = incidentEdges[i];

        incidentEdges = aedge;
        Node anode[] = new Node[allocation * 2];
        for(int j = 0; j < allocation; j++)
            anode[j] = neighbors[j];

        neighbors = anode;
        allocation = allocation * 2;
    }

    public Node()
    {
        allocation = DEFAULT_ALLOCATION;
        name = "";
        placed = false;
        fixed = false;
        incidentEdges = new Edge[DEFAULT_ALLOCATION];
        neighbors = new Node[DEFAULT_ALLOCATION];
    }

    public Node(String s)
    {
        allocation = DEFAULT_ALLOCATION;
        name = "";
        placed = false;
        fixed = false;
        incidentEdges = new Edge[DEFAULT_ALLOCATION];
        neighbors = new Node[DEFAULT_ALLOCATION];
        name = s;
    }

    public Node(String s, int i, int j)
    {
        allocation = DEFAULT_ALLOCATION;
        name = "";
        placed = false;
        fixed = false;
        incidentEdges = new Edge[DEFAULT_ALLOCATION];
        neighbors = new Node[DEFAULT_ALLOCATION];
        name = s;
        width = i;
        height = j;
    }

    public Node(Node node)
    {
        allocation = DEFAULT_ALLOCATION;
        name = "";
        placed = false;
        fixed = false;
        incidentEdges = new Edge[DEFAULT_ALLOCATION];
        neighbors = new Node[DEFAULT_ALLOCATION];
        name = node.name;
        width = node.width;
        height = node.height;
        x = node.x;
        y = node.y;
        degree = node.degree;
        if((allocation = node.allocation) > 0)
        {
            incidentEdges = new Edge[allocation];
            neighbors = new Node[allocation];
            for(int i = 0; i < degree; i++)
            {
                incidentEdges[i] = node.incidentEdges[i];
                neighbors[i] = node.neighbors[i];
            }

        }
    }

    public Node(String s, Barycenter barycenter1)
    {
        allocation = DEFAULT_ALLOCATION;
        name = "";
        placed = false;
        fixed = false;
        incidentEdges = new Edge[DEFAULT_ALLOCATION];
        neighbors = new Node[DEFAULT_ALLOCATION];
        name = s;
        barycenter = barycenter1;
    }

    public boolean addNeighbor(Edge edge)
    {
        if(edge == null || this != edge.from && this != edge.to)
            return false;
        if(degree == allocation)
            doubleArrays();
        incidentEdges[degree] = edge;
        neighbors[degree++] = this != edge.from ? edge.from : edge.to;
        return true;
    }

    public boolean removeNeighbor(Node node)
    {
        for(int i = 0; i < degree; i++)
            if(neighbors[i] == node)
            {
                incidentEdges[i] = incidentEdges[degree - 1];
                neighbors[i] = neighbors[degree - 1];
                degree = degree - 1;
                return true;
            }

        return false;
    }

    public boolean removeNeighbor(Edge edge)
    {
        for(int i = 0; i < degree; i++)
            if(incidentEdges[i] == edge)
            {
                incidentEdges[i] = incidentEdges[degree - 1];
                neighbors[i] = neighbors[degree - 1];
                degree = degree - 1;
                return true;
            }

        return false;
    }

    public double distance(Node node)
    {
        return Math.sqrt(distanceSquared(node));
    }

    public synchronized double distanceSquared(Node node)
    {
        return My.square(x - node.x) + My.square(y - node.y);
    }

    public double distance(Edge edge)
    {
        return Math.sqrt(distanceSquared(edge));
    }

    public synchronized double distanceSquared(Edge edge)
    {
        double d = x - edge.from.x;
        double d1 = y - edge.from.y;
        double d2 = edge.to.x - edge.from.x;
        double d3 = edge.to.y - edge.from.y;
        double d4 = (d * d2 + d1 * d3) / (d2 * d2 + d3 * d3);
        if(d4 <= 0.0D)
            return distanceSquared(edge.from);
        if(d4 >= 1.0D)
            return distanceSquared(edge.to);
        else
            return My.square(d - d4 * d2) + My.square(d1 - d4 * d3);
    }

    private static int DEFAULT_ALLOCATION = 10;
    private int allocation;
    public String name;
    public int width;
    public int height;
    public double x;
    public double y;
    public boolean placed;
    public boolean fixed;
    public int degree;
    public Edge incidentEdges[];
    public Node neighbors[];
    public Barycenter barycenter;

}